/*
 * Copyright (C) 2012 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#define ADK_INTERNAL
#include "fwk.h"
#include "BT.h"
#include "HCI.h"
#include "dbg.h"
#include "coop.h"
#include "sgBuf.h"

#define BT_TASK_STACK_SIZE  3000
uint32_t bt_task_handle = 0;

int bt_init_done = 0;
extern void l2capAclLinkDownAll();
extern unsigned int usbdev_check_attached();


#define BT_VERBOSE		0

#define PACKET_RX_BACKLOG_SZ	4
#if  defined(BT_MODULE_CC256X)
extern const uint8_t cc256x_init_script[];
#endif

static uint8_t* backlog[PACKET_RX_BACKLOG_SZ] = {0, };
static uint8_t btThreadDie;
static BtFuncs cbks;

#define RESET		PORTA(0)
#define TX		PORTA(10)
#define RX		PORTA(11)
#define RTS		PORTB(25)
#define CTS		PORTB(26)

// liutest add
#define PACKET_STORE_MAXSZ (BT_RX_BUF_SZ)
static uint32_t packetStore[(BT_RX_BUF_SZ + 3) >> 2];
static uint8_t* packet = (uint8_t*)packetStore;
static uint8_t pageState;
static uint16_t gAclPacketsCanSend = 0;

typedef struct BtEnqueuedNode{

    struct BtEnqueuedNode* next;

    sg_buf* buf;
    uint16_t conn;
    char first;
    uint8_t bcastType;

}BtEnqueuedNode;

BtEnqueuedNode* enqueuedPackets = NULL;

static char btDiscoverableConnectable(void);

static uint8_t* hciCmdPacketStart(uint16_t ogf, uint16_t ocf){		//start a packet in "packet", return "state" pointer

    HCI_Cmd* cmd = (HCI_Cmd*)packetStore;

    cmd->opcode = HCI_OPCODE(ogf, ocf);
    return packet + 3;
}

static uint8_t* hciCmdPacketAddU32(uint8_t* state, uint32_t val){	//add a uint32 to packet, update state

    *state++ = val;
    *state++ = val >> 8;
    *state++ = val >> 16;
    *state++ = val >> 24;

    return state;
}

static uint8_t* hciCmdPacketAddU24(uint8_t* state, uint32_t val){	//add a uint24 to packet, update state

    *state++ = val;
    *state++ = val >> 8;
    *state++ = val >> 16;

    return state;
}

static uint8_t* hciCmdPacketAddU16(uint8_t* state, uint16_t val){	//add a uint32 to packet, update state

    *state++ = val;
    *state++ = val >> 8;

    return state;
}

static uint8_t* hciCmdPacketAddU8(uint8_t* state, uint8_t val){		//add a uint32 to packet, update state

    *state++ = val;

    return state;
}

static uint32_t hciCmdPacketFinish(uint8_t* state){			//finish, return size to send

    HCI_Cmd* cmd = (HCI_Cmd*)packetStore;
    uint32_t paramLen = state - packet - 3;

    cmd->totalParamLen = paramLen;
    return paramLen + 3;
}

static void btTxCmdPacketEx(const HCI_Cmd* cmd){

    uint8_t typ = UART_PKT_TYP_CMD;
hci_write (typ, (uint8_t*)cmd, 3 + cmd->totalParamLen);
    //btUartSend(&typ, 1);
    //btUartSend((uint8_t*)cmd, 3 + cmd->totalParamLen);	//cannot use sizeof thanks to gcc
}

static void btTxCmdPacket(void){

   btTxCmdPacketEx((HCI_Cmd*)packetStore);
}

static void btAclDataTxBuf(uint16_t conn, char first, uint8_t bcastType, const uint8_t* data, uint16_t sz){

    uint8_t typ = UART_PKT_TYP_ACL;
    HCI_ACL_Data* acl = (HCI_ACL_Data*)packetStore;
    acl->info = conn | (first ? 0x2000 : 0x1000) | ((uint32_t)bcastType) << 14;
    acl->totalDataLen = sz;
#if 0
    if(sz <= PACKET_STORE_MAXSZ - 4) {
       memcpy( ((uint8_t*)packetStore) + 4,data,sz);
       hci_write (typ, (uint8_t*)acl, 4  + sz);
    }
    else {
       hci_write (typ, (uint8_t*)acl, 4 );
       hci_write (typ, (uint8_t*)data, sz );
    }
#else
       hci_write (typ, (uint8_t*)acl, 4 );
       hci_write (typ, (uint8_t*)data, sz );
#endif

    //btUartSend(&typ, 1);
    //btUartSend((uint8_t*)acl, 4);
    //btUartSend(data, sz);
}

static void btAclDoDataTx(uint16_t conn, char first, uint8_t bcastType, sg_buf* buf){

#if 0
    sg_iter iter;
    uint8_t typ = UART_PKT_TYP_ACL;
    HCI_ACL_Data* acl = (HCI_ACL_Data*)packetStore;
    const uint8_t* data;
    uint32_t len ,total = 4;

    gAclPacketsCanSend --;
    acl->info = conn | (first ? 0x2000 : 0x1000) | ((uint32_t)bcastType) << 14;
    acl->totalDataLen = sg_length(buf);

    // total = 4;
        
    iter = sg_iter_start(buf);
    while(sg_iter_next(&iter, &data, &len)) {
        if ((total + len) >1024) {
            hci_write (typ, (uint8_t*)acl, total );
            printf("acl tx total %d\n",len);
            acl = (HCI_ACL_Data*)packetStore;
            total = len;
        }
        else {
            memcpy(((uint8_t *)acl + total),data,len);
            total += len;
        }
    }

    if(total > 0) {
            hci_write (typ, (uint8_t*)acl, total );
    }

    //btUartSend(&typ, 1);
    //btUartSend((uint8_t*)acl, 4);
    //iter = sg_iter_start(buf);
    //while(sg_iter_next(&iter, &data, &len))  btUartSend(data, len);

    sg_free(buf);
    free(buf);
#else
    sg_iter iter;
    uint8_t typ = UART_PKT_TYP_ACL;
    HCI_ACL_Data* acl = (HCI_ACL_Data*)packetStore;
    const uint8_t* data;
    uint32_t len;

    gAclPacketsCanSend --;
    acl->info = conn | (first ? 0x2000 : 0x1000) | ((uint32_t)bcastType) << 14;
    acl->totalDataLen = sg_length(buf);

    hci_write (typ, (uint8_t*)acl, 4 );
    //printf("acl4\n");
 
    iter = sg_iter_start(buf);
    while(sg_iter_next(&iter, &data, &len)) {/* printf("acl%d\n",len);*/ hci_write (typ, (uint8_t*)data, len );}

    sg_free(buf);
    free(buf);
#endif
}

void btAclDataTx(uint16_t conn, char first, uint8_t bcastType, sg_buf* buf){

    if(gAclPacketsCanSend){

        btAclDoDataTx(conn, first, bcastType, buf);
    }
    else{

        BtEnqueuedNode *q = enqueuedPackets, *n = malloc(sizeof(BtEnqueuedNode));
        if(!n){

            //packet dropped due to lack of memory...sorry
            sg_free(buf);
            free(buf);
            return;
        }
        n->buf = buf;
        n->conn = conn;
        n->first = first;
        n->bcastType = bcastType;
        n->next = NULL;

        while(q && q->next) q = q->next;
        if(q) q->next = n;
        else enqueuedPackets = n;
    }
}

static void btEnqueuePacket(uint8_t typ){	//we got a packet but it's not for us - enqueue it for someone else to use

    uint8_t* copy;
    unsigned sz, i;

    switch(typ){
        case UART_PKT_TYP_ACL:
            sz = ((HCI_ACL_Data*)packetStore)->totalDataLen + 4L;
            break;

        case UART_PKT_TYP_SCO:
            sz = ((HCI_SCO_Data*)packetStore)->totalDataLen + 3L;
            break;

        case UART_PKT_TYP_EVT:
            sz = ((HCI_Event*)packetStore)->totalParamLen + 2L;
            if(!bt_init_done) 
                printf("EVT:%d\n",sz);
            break;

        default:
            //no idea what it is...drop it on the floor
            return;
    }

    copy = malloc(sz + 1);
    if(!copy) return; //cannot alloc -> fail

    copy[0] = typ;
    for(i = 0; i < sz; i++) copy[i + 1] = packet[i];
    for(i = 0; i < PACKET_RX_BACKLOG_SZ; i++) if(!backlog[i]) break;
    if(i == PACKET_RX_BACKLOG_SZ){ //we have to drop something

        #if BT_VERBOSE

            dbgPrintf("BT: dropping backlog item: %d, 0x%x\n", backlog[0][0], backlog[0][1]);

        #endif
        free(backlog[0]);
        for(i = 0; i < PACKET_RX_BACKLOG_SZ - 1; i++) backlog[i] = backlog[i + 1];
    }
    backlog[i] = copy;
}

static uint8_t btRxPacket(void){  //return type

    uint8_t typ;
    uint8_t* dst;
    unsigned sz,acl_len;

    sz = BT_RX_BUF_SZ;
    dst = packet ;
    if(!hci_read ((HCI_TYPE *)&typ, dst,&sz))   // todo judge sz in the hci_read
        return 0;
    
    switch(typ){
        case UART_PKT_TYP_ACL:
            acl_len = ((HCI_ACL_Data*)packetStore)->totalDataLen;
            break;

        case UART_PKT_TYP_SCO:
            acl_len = ((HCI_SCO_Data*)packetStore)->totalDataLen;
            break;

        case UART_PKT_TYP_EVT:
            acl_len = ((HCI_Event*)packetStore)->totalParamLen;
            break;

        default:
            //no idea what it is...drop it on the floor
            printf("no idea what it is...drop it on the floor\n");
            return 0;
    }

    if(sz > BT_RX_BUF_SZ) {
         dbgPrintf("BT: Incoming packet too big. Dropping hcilen=%d,acllen=%d\n",sz,acl_len);
         return 0;
    }

    
    #if BT_VERBOSE
    {
        uint8_t *start = packet, *end = dst + sz;

        dbgPrintf("RX: %02X", typ);
        while(start < end) dbgPrintf(" %02X", *start++);
        dbgPrintf("\n");
    }
    #endif

    return typ;
}

static void btTaskF(void* ptr){

    HCI_Event* e = (HCI_Event*)packetStore;
    HCI_ACL_Data* acl = (HCI_ACL_Data*)packetStore;
    uint8_t* packetState;
    uint16_t conn;
    uint8_t mac[6];
    uint8_t buf[16];
    unsigned i, j;

    printf("btTaskF start\n");
    while(!btThreadDie && usbdev_check_attached()){

        uint8_t typ;

        if((typ = btRxPacket())){
            //printf("1\n");
            if ((!bt_init_done) &&  ((typ >= UART_PKT_TYP_CMD) ||(typ <= UART_PKT_TYP_EVT))) {
                btEnqueuePacket(typ);
                continue;
            }
                

            if(typ == UART_PKT_TYP_ACL){
                cbks.BtAclDataRxF(cbks.userData, acl->info & 0x0FFF, ((acl->info >> 12) & 3) == 2, acl->info >> 14, acl->data, acl->totalDataLen); /* btAclDataRxF */
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Connection_Request_Event){
                //printf("UART_PKT_TYP_EVT\n"); 
                uint32_t dc = e->params[6] + (((uint32_t)e->params[7]) << 8) + (((uint32_t)e->params[8]) << 16);

                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];

                if(cbks.BtConnReqF(cbks.userData, mac, dc, e->params[9])){ //accept it

                    packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_Accept_Connection_Request);
                    i = 1;
                }
                else{ //reject it

                    packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_Reject_Connection_Request);
                    i = 0x0F; //rejected...
                }
                packetState = hciCmdPacketAddU8(packetState, mac[0]);
                packetState = hciCmdPacketAddU8(packetState, mac[1]);
                packetState = hciCmdPacketAddU8(packetState, mac[2]);
                packetState = hciCmdPacketAddU8(packetState, mac[3]);
                packetState = hciCmdPacketAddU8(packetState, mac[4]);
                packetState = hciCmdPacketAddU8(packetState, mac[5]);
                packetState = hciCmdPacketAddU8(packetState, i); //we'll be the slave on the connection...for now
                hciCmdPacketFinish(packetState);
                btTxCmdPacket();
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Connection_Complete_Event && !e->params[0]){

                conn = e->params[1] + (((uint32_t)e->params[2]) << 8);
                printf("new connect %d\n",conn);

                cbks.BtConnStartF(cbks.userData, conn, e->params + 3, e->params[9], e->params[10]);
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Disconnection_Complete_Event){

                BtEnqueuedNode *t, *n = enqueuedPackets, *p = NULL;
                conn = e->params[1] + (((uint32_t)e->params[2]) << 8);
                //printf("get disconnect %d\n",conn);

                cbks.BtConnEndF(cbks.userData, conn, e->params[3]);

                while(n){

                    if(n->conn == conn){

                        if(p) p->next = n->next;
                        else enqueuedPackets = n->next;
                        t = n;
                        n = n->next;
                        sg_free(t->buf);
                        free(t->buf);
                        free(t);
                    }
                    else{

                        p = n;
                        n = n->next;
                    }
                }
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_PIN_Code_Request_Event){
                //printf("HCI_EVT_PIN_Code_Request_Event\n");

                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];
                i = cbks.BtPinRequestF(cbks.userData, mac, buf);
                packetState = hciCmdPacketStart(HCI_OGF_Link_Control, i ? HCI_CMD_PIN_Code_Request_Reply : HCI_CMD_PIN_Code_Request_Negative_Reply);
                packetState = hciCmdPacketAddU8(packetState, mac[0]);
                packetState = hciCmdPacketAddU8(packetState, mac[1]);
                packetState = hciCmdPacketAddU8(packetState, mac[2]);
                packetState = hciCmdPacketAddU8(packetState, mac[3]);
                packetState = hciCmdPacketAddU8(packetState, mac[4]);
                packetState = hciCmdPacketAddU8(packetState, mac[5]);
                
                if(i){ //accept

                    packetState = hciCmdPacketAddU8(packetState, i);
                    for(j = 0; j < 16; j++) packetState = hciCmdPacketAddU8(packetState, buf[j]);
                }
                hciCmdPacketFinish(packetState);
                btTxCmdPacket();
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Number_Of_Completed_Packets_Event){

                uint8_t numHandles = e->params[0];
                //printf("HCI_EVT_Number_Of_Completed_Packets_Event\n");
                for(i = 0; i < numHandles; i++) gAclPacketsCanSend += (((uint16_t)e->params[1 + i * 4 + 3]) << 8) | e->params[1 + i * 4 + 2];

                while(gAclPacketsCanSend && enqueuedPackets){

                    BtEnqueuedNode* n = enqueuedPackets;

                    enqueuedPackets = n->next;
                    btAclDoDataTx(n->conn, n->first, n->bcastType, n->buf);
                    free(n);
                }
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Link_Key_Request_Event){
                //printf("HCI_EVT_Link_Key_Request_Event\n");
                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];
                i = cbks.BtLinkKeyRequestF(cbks.userData, mac, buf);
                packetState = hciCmdPacketStart(HCI_OGF_Link_Control, i ? HCI_CMD_Link_Key_Request_Reply : HCI_CMD_Link_Key_Request_Negative_Reply);
                packetState = hciCmdPacketAddU8(packetState, mac[0]);
                packetState = hciCmdPacketAddU8(packetState, mac[1]);
                packetState = hciCmdPacketAddU8(packetState, mac[2]);
                packetState = hciCmdPacketAddU8(packetState, mac[3]);
                packetState = hciCmdPacketAddU8(packetState, mac[4]);
                packetState = hciCmdPacketAddU8(packetState, mac[5]);
                
                if(i){ //link key given to us

                    for(j = 0; j < 16; j++) packetState = hciCmdPacketAddU8(packetState, buf[j]);
                }
                hciCmdPacketFinish(packetState);
                btTxCmdPacket();  /* run to this pendig */
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Link_Key_Notification_Event){
                //printf("HCI_EVT_Link_Key_Notification_Event\n");
                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];
                for(i = 0; i < 16; i++) buf[i] = e->params[i + sizeof(mac)];

                cbks.BtLinkKeyCreatedF(cbks.userData, mac, buf);
            }
        #if SUPORT_SSP //this was done last minute, but should work :) -DG

            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_IO_Capability_Request_Event){

                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];

                packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_IO_Capability_Request_Reply);
                packetState = hciCmdPacketAddU8(packetState, mac[0]);
                packetState = hciCmdPacketAddU8(packetState, mac[1]);
                packetState = hciCmdPacketAddU8(packetState, mac[2]);
                packetState = hciCmdPacketAddU8(packetState, mac[3]);
                packetState = hciCmdPacketAddU8(packetState, mac[4]);
                packetState = hciCmdPacketAddU8(packetState, mac[5]);
                
                packetState = hciCmdPacketAddU8(packetState, 0); //we claim to be display-only - it works for us
                packetState = hciCmdPacketAddU8(packetState, 0); //we do not support OOB
                packetState = hciCmdPacketAddU8(packetState, 2); //we don't care about MITM and like Dedicated Bonding
                hciCmdPacketFinish(packetState);
                btTxCmdPacket();
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_User_Confirmation_Request_Event){

                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];
                uint32_t val = 0;

                for(i = 0; i < 4; i++) val = (val << 8) | e->params[sizeof(mac) + 3 - i];

                //we are disaply-only so accept it unconditionally
                packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_User_Confirmation_Request_Reply);
                packetState = hciCmdPacketAddU8(packetState, mac[0]);
                packetState = hciCmdPacketAddU8(packetState, mac[1]);
                packetState = hciCmdPacketAddU8(packetState, mac[2]);
                packetState = hciCmdPacketAddU8(packetState, mac[3]);
                packetState = hciCmdPacketAddU8(packetState, mac[4]);
                packetState = hciCmdPacketAddU8(packetState, mac[5]);
                hciCmdPacketFinish(packetState);
                btTxCmdPacket();

                cbks.BtSspShow(cbks.userData, mac, val);
            }
            else if(typ == UART_PKT_TYP_EVT && e->eventCode == HCI_EVT_Simple_Pairing_Complete_Event){

                for(i = 0; i < sizeof(mac); i++) mac[i] = e->params[i];
                uint32_t val = 0;

                for(i = 0; i < 4; i++) val = (val << 8) | e->params[sizeof(mac) + 3 - i];

                cbks.BtSspShow(cbks.userData, mac, BT_SSP_DONE_VAL);
            }

        #endif
            else{
                //printf("btEnqueuePacket\n");
                if ((typ >= UART_PKT_TYP_CMD) ||(typ <= UART_PKT_TYP_EVT))  btEnqueuePacket(typ);
            }
        }
    }

    printf("free enqueuedPackets \n");
       
    // free all connect enqueuedpakets memory after task exit
    {
        BtEnqueuedNode *t, *n = enqueuedPackets;
            
        while(n){
            printf("disconnet %d\n",n->conn);
            cbks.BtConnEndF(cbks.userData, n->conn, 0);  // btConnEndF

            //enqueuedPackets = n->next;
            t = n;
            n = n->next;
            sg_free(t->buf);
            free(t->buf);
            free(t);
        }
        ASSERT(enqueuedPackets == NULL);
        l2capAclLinkDownAll();
    }
     printf("btThreadDie = 1\n");
    //btThreadDie = 0;
    btThreadDie = 1;

    //OS_Task_suspend(0);  /* block this task */
}

static char btTryRxEventPacket(uint8_t wantedType){

    uint8_t i, j;

    for(i = 0; i < PACKET_RX_BACKLOG_SZ; i++){

        if(backlog[i] && backlog[i][0] == UART_PKT_TYP_EVT && (!wantedType || backlog[i][1] == wantedType)){

            for(j = 0; j < 2; j++) packet[j] = backlog[i][j + 1]; //copy packet header
            for(j = 0; j < ((HCI_Event*)packetStore)->totalParamLen; j++) packet[j + 2] = backlog[i][j + 3];
            free(backlog[i]);
            for(; i < PACKET_RX_BACKLOG_SZ - 1; i++) backlog[i] = backlog[i + 1];
            backlog[i] = NULL;
            return 1;
        }
    }
    return 0;
}

static void btRxEventPacket(uint8_t wantedType){

    while ((!btTryRxEventPacket(wantedType))  && usbdev_check_attached()) coopYield();
}

char btInit(const BtFuncs* btf){

    HCI_Cmd* cmd;
    HCI_Event* evt = (HCI_Event*)packetStore;
    int num = 0;
#if  defined(BT_MODULE_CC256X)
    const uint8_t* script = cc256x_init_script;
#endif
    uint8_t* packetState;
    int i;

    dbgPrintf("inBtInit\n");
    bt_init_done = 0;

    btThreadDie = 0;
    if(!coopSpawn(btTaskF, NULL, /*2048*/BT_TASK_STACK_SIZE,&bt_task_handle)){
        dbgPrintf("Failed to start BT task\n");
        return 0;
    }
    dbgPrintf("Bt initing...\n");

#if  defined(BT_MODULE_CC256X)
    //init script
    while(*script++){

        dbgPrintf("\r%d", num++);
        cmd = (HCI_Cmd*)script;
        btTxCmdPacketEx(cmd);
        script += 3 + cmd->totalParamLen;
        btRxEventPacket(0);
        #if BT_VERBOSE
            dbgPrintf(" -> %d, %d:", evt->eventCode ,evt->totalParamLen);
            for(i = 0; i < evt->totalParamLen; i++) dbgPrintf(" %02X", evt->params[i]);
            dbgPrintf("\n");
        #endif
    }
#else
    // Reset 
#if 1
        dbgPrintf("Bt Reset...\n");
        packetState = hciCmdPacketStart(HCI_OGF_Controller_and_Baseband, HCI_CMD_Reset);
        hciCmdPacketFinish(packetState);
        btTxCmdPacket();
        btRxEventPacket(HCI_EVT_Command_Complete_Event);
        dbgPrintf("Bt Reset,end\n");
#endif
#endif

    //get buffer size
    packetState = hciCmdPacketStart(HCI_OGF_Informational, HCI_CMD_Read_Buffer_Size);
    hciCmdPacketFinish(packetState);
    btTxCmdPacket();
    do{
        btRxEventPacket(HCI_EVT_Command_Complete_Event);
    }while(evt->params[1] != (HCI_OPCODE(HCI_OGF_Informational, HCI_CMD_Read_Buffer_Size) & 0xFF) ||
              evt->params[2] != (HCI_OPCODE(HCI_OGF_Informational, HCI_CMD_Read_Buffer_Size) >> 8));

    uint16_t aclLen, aclNum, scoNum;
    uint8_t scoLen;

    aclLen = (((uint16_t)evt->params[5]) << 8) | evt->params[4];
    scoLen = evt->params[6];
    aclNum = (((uint16_t)evt->params[8]) << 8) | evt->params[7];
    scoNum = (((uint16_t)evt->params[10]) << 8) | evt->params[9];

    #if BT_VERBOSE
        dbgPrintf("BT chip buffers: %ux%ub ACL, %ux%ub SCO\n", aclNum, aclLen, scoNum, scoLen);
    #endif

    gAclPacketsCanSend = aclNum;

    //set connectibility/discoverability
    pageState = 0;
    btDiscoverableConnectable();

    //enable simple passcodes
    if(SUPORT_SSP){
      packetState = hciCmdPacketStart(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Simple_Pairing_Mode);
      packetState = hciCmdPacketAddU8(packetState, 1); //enable it
      hciCmdPacketFinish(packetState);
      btTxCmdPacket();
      do{
        btRxEventPacket(HCI_EVT_Command_Complete_Event);
      }while(evt->params[1] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Simple_Pairing_Mode) & 0xFF) ||
              evt->params[2] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Simple_Pairing_Mode) >> 8));
    }

    cbks = *btf;   // move before start btTaskF

    dbgPrintf("\nBT up\n");
    bt_init_done  = 1;

    return 1;
}

void btDeinit(void){

    int i;

    // btThreadDie = 1;
    while((btThreadDie == 0)  && (bt_task_handle != 0) )  coopYield();

    if(bt_task_handle != 0) {
        coopDoom(bt_task_handle);
        bt_task_handle = 0;
    }
        

    for(i = 0; i < PACKET_RX_BACKLOG_SZ; i++) if(backlog[i]) free(backlog[i]);
}

char btLocalMac(uint8_t* buf){

    int i;
    HCI_Event* evt = (HCI_Event*)packetStore;
    uint8_t* packetState;

    packetState = hciCmdPacketStart(HCI_OGF_Informational, HCI_CMD_Read_BD_ADDR);
    hciCmdPacketFinish(packetState);
    btTxCmdPacket();
    btRxEventPacket(HCI_EVT_Command_Complete_Event);
    if(evt->totalParamLen != 10 ||
          evt->params[1] != (HCI_OPCODE(HCI_OGF_Informational, HCI_CMD_Read_BD_ADDR) & 0xFF) ||
          evt->params[2] != (HCI_OPCODE(HCI_OGF_Informational, HCI_CMD_Read_BD_ADDR) >> 8) || evt->params[3] != 0){
        return 0;
    }

    for(i = 0; i < 6; i++) buf[i] = evt->params[4 + i];
    return 1;
}

char btSetLocalName(const char* name){

    HCI_Cmd* cmd = (HCI_Cmd*)packetStore;
    HCI_Event* evt = (HCI_Event*)packetStore;
    uint8_t* packetState;

    packetState = hciCmdPacketStart(HCI_OGF_Controller_and_Baseband, HCI_CMD_Change_Local_Name);
    while(name && *name) packetState = hciCmdPacketAddU8(packetState, *name++);
    packetState = hciCmdPacketAddU8(packetState, 0);
    hciCmdPacketFinish(packetState);
    if(cmd->totalParamLen > 248) return 0;	//too long
    cmd->totalParamLen = 248;
    btTxCmdPacket();
    btRxEventPacket(HCI_EVT_Command_Complete_Event);
    
    if(evt->totalParamLen != 4 ||
          evt->params[1] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Change_Local_Name) & 0xFF) ||
          evt->params[2] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Change_Local_Name) >> 8) || evt->params[3] != 0){
        return 0;
    }
    return 1;
}

void btScan(void){

    //HCI_Cmd* cmd = (HCI_Cmd*)packet;
    HCI_Event* evt = (HCI_Event*)packet;
    uint8_t* packetState;
    int i, done = 0;

    packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_Inquiry);
    packetState = hciCmdPacketAddU24(packetState, HCI_LAP_Unlimited_Inquiry);
    packetState = hciCmdPacketAddU8(packetState, 0x30);
    packetState = hciCmdPacketAddU8(packetState, 0);
    hciCmdPacketFinish(packetState);
    btTxCmdPacket();

    while(1){
        coopYield();
        if(!done && btTryRxEventPacket(HCI_EVT_Inquiry_Result_Event)){

            uint8_t* MACs  = evt->params + evt->params[0]*0  + 1;
            uint8_t* PSRMs = evt->params + evt->params[0]*6  + 1;
            uint8_t* PSPMs = evt->params + evt->params[0]*7  + 1;
            uint8_t* PSMs  = evt->params + evt->params[0]*8  + 1;
            uint8_t* DCs   = evt->params + evt->params[0]*9  + 1;
            uint8_t* COs   = evt->params + evt->params[0]*12 + 1;

            for(i = 0; i < evt->params[0]; i++){

                BtDiscoveryResult dr;

                dr.dc = DCs[0] + (((uint32_t)DCs[1]) << 8) + (((uint32_t)DCs[2]) << 16)         ;     
                dr.mac[0] = *MACs++;
                dr.mac[1] = *MACs++;
                dr.mac[2] = *MACs++;
                dr.mac[3] = *MACs++;
                dr.mac[4] = *MACs++;
                dr.mac[5] = *MACs++;
                dr.PSRM = *PSRMs++;
                dr.PSPM = *PSPMs++;
                dr.PSM = *PSMs++;
                dr.co = (((uint16_t)COs[1]) << 8) + COs[0];

                if(!cbks.BtDiscoveryF(cbks.userData, &dr)){

                    packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_Inquiry_Cancel);
                    hciCmdPacketFinish(packetState);
                    btTxCmdPacket();
                    done = 1;
                    break;
                }
                COs += 2;
                DCs += 3;
            }
        }
        if(btTryRxEventPacket(HCI_EVT_Inquiry_Complete_Event)) break;
        if(btTryRxEventPacket(HCI_EVT_Command_Complete_Event)) break;
    }
}

char btGetRemoteName(const uint8_t* mac, uint8_t PSRM, uint8_t PSM, uint16_t co, char* nameBuf){

    HCI_Event* evt = (HCI_Event*)packet;
    uint8_t* packetState;
    int i = 0;

    packetState = hciCmdPacketStart(HCI_OGF_Link_Control, HCI_CMD_Remote_Name_Request);
    packetState = hciCmdPacketAddU8(packetState, mac[0]);
    packetState = hciCmdPacketAddU8(packetState, mac[1]);
    packetState = hciCmdPacketAddU8(packetState, mac[2]);
    packetState = hciCmdPacketAddU8(packetState, mac[3]);
    packetState = hciCmdPacketAddU8(packetState, mac[4]);
    packetState = hciCmdPacketAddU8(packetState, mac[5]);
    packetState = hciCmdPacketAddU8(packetState, PSRM);
    packetState = hciCmdPacketAddU8(packetState, PSM);
    packetState = hciCmdPacketAddU16(packetState, co);
    hciCmdPacketFinish(packetState);
    btTxCmdPacket();

    btRxEventPacket(HCI_EVT_Remote_Name_Request_Complete_Event);

    if(evt->params[0] == 0){

        while(i < 248 && evt->params[7 + i]){
            nameBuf[i] = evt->params[7 + i];
            i++;
        }
        nameBuf[i] = 0;
        return 1;
    }
    else return 0;
}

static char btDiscoverableConnectable(void){

    HCI_Event* evt = (HCI_Event*)packet;
    uint8_t* packetState;

    packetState = hciCmdPacketStart(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Scan_Enable);
    packetState = hciCmdPacketAddU8(packetState, pageState);
    hciCmdPacketFinish(packetState);
    btTxCmdPacket();
    btRxEventPacket(HCI_EVT_Command_Complete_Event);
    if(evt->totalParamLen != 4 ||
          evt->params[1] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Scan_Enable) & 0xFF) ||
          evt->params[2] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Scan_Enable) >> 8) || evt->params[3] != 0){
        return 0;
    }

    return 1;
}

char btDiscoverable(char on){

    uint8_t nv = (pageState &~ PAGE_STATE_INQUIRY) | (on ? PAGE_STATE_INQUIRY : 0);
    if(nv == pageState) return 1;
    pageState = nv;

    return btDiscoverableConnectable();
}

char btConnectable(char on){

    uint8_t nv = (pageState &~ PAGE_STATE_PAGE) | (on ? PAGE_STATE_PAGE : 0);
    if(nv == pageState) return 1;
    pageState = nv;

    return btDiscoverableConnectable();
}

char btSetDeviceClass(uint32_t cls){

    HCI_Event* evt = (HCI_Event*)packet;
    uint8_t* packetState;

    packetState = hciCmdPacketStart(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Class_Of_Device);
    packetState = hciCmdPacketAddU24(packetState, cls);
    hciCmdPacketFinish(packetState);
    btTxCmdPacket();
    btRxEventPacket(HCI_EVT_Command_Complete_Event);
    if(evt->totalParamLen != 4 ||
          evt->params[1] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Class_Of_Device) & 0xFF) ||
          evt->params[2] != (HCI_OPCODE(HCI_OGF_Controller_and_Baseband, HCI_CMD_Write_Class_Of_Device) >> 8) || evt->params[3] != 0){
        return 0;
    }

    return 1;
}













#if  defined(BT_MODULE_CC256X)
const uint8_t cc256x_init_script[] = {
    // #--------------------------------------------------------------------------------
    // # Description : Trio Orca 5500 L ROM Initialization Script
    // #
    // # Compatibility: Trio/Orca/5500, 6.0.15 ROM
    // #
    // # Last Updated: 09-Aug-2011  10:06:07.86
    // #
    // # Version     : TI_P6_15.41
    // #
    // #
    // #
    // # Trio LMP Subversion: 1f29
    // # Orca LMP Subversion: 1b29
    // #
    // # Notes       : Use this script on Trio, Orca or 5500, 6.0.15 ROM device only (FW v6.0.15)
    // #--------------------------------------------------------------------------------
    // 
    // #################################################################
    // ## START of Panasonic Adds-On
    // #################################################################
    // 
    // ## Change UART baudrate
    // 
    // 
    // #################################################################
    // ## END of Panasonic Adds-On
    // #################################################################
    // 
    0x01, 0x37, 0xfe, 0x02, 0x06, 0x0f, 

    // 
    // 
    0x01, 0x05, 0xff, 0xff, 0xa0, 0x62, 0x08, 0x00, 0xfa, 0x06, 0x0f, 0x3d, 0x29, 0x05, 0xc0, 
    0x03, 0xc0, 0x1e, 0x08, 0x05, 0x00, 0x04, 0xc0, 0x03, 0xc0, 0x1e, 0x08, 0x3d, 0x01, 0x04, 
    0xc0, 0x03, 0xc0, 0x1e, 0x08, 0x76, 0x02, 0x04, 0xc0, 0x03, 0xc0, 0x1e, 0x08, 0xae, 0x03, 
    0x04, 0xc0, 0x03, 0xc0, 0x1e, 0x08, 0xae, 0x0b, 0x01, 0x00, 0x34, 0x30, 0x41, 0x02, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0xb9, 0x58, 0x00, 0x00, 0x1b, 0x59, 0x00, 0x00, 0x40, 0x59, 
    0x00, 0x00, 0x41, 0x59, 0x00, 0x00, 0x65, 0x59, 0x00, 0x00, 0xdc, 0x74, 0x00, 0x00, 0xdd, 
    0x74, 0x00, 0x00, 0x4b, 0xf4, 0x00, 0x00, 0x5c, 0xf4, 0x00, 0x00, 0x5d, 0xf4, 0x00, 0x00, 
    0xcb, 0xf4, 0x00, 0x00, 0xdc, 0xf4, 0x00, 0x00, 0xdd, 0xf4, 0x00, 0x00, 0x40, 0x19, 0x02, 
    0x00, 0x48, 0x19, 0x02, 0x00, 0xdb, 0x48, 0x02, 0x00, 0x1c, 0x49, 0x02, 0x00, 0x40, 0x49, 
    0x02, 0x00, 0x41, 0x49, 0x02, 0x00, 0x45, 0x49, 0x02, 0x00, 0xb9, 0x50, 0x02, 0x00, 0x45, 
    0x51, 0x02, 0x00, 0x1b, 0x58, 0x02, 0x00, 0x1c, 0x58, 0x02, 0x00, 0x38, 0x58, 0x02, 0x00, 
    0x41, 0x58, 0x02, 0x00, 0x98, 0x58, 0x02, 0x00, 0xb8, 0x58, 0x02, 0x00, 0xb9, 0x58, 0x02, 
    0x00, 0xdb, 0x58, 0x02, 0x00, 0xdc, 0x58, 0x02, 0x00, 0x01, 0x59, 0x02, 0x00, 0x05, 0x59, 
    0x02, 0x00, 0x18, 0x59, 0x02, 0x00, 0x19, 0x59, 0x02, 0x00, 0x1b, 0x59, 0x02, 0x00, 0x1c, 
    0x59, 0x02, 0x00, 0x40, 0x59, 0x02, 0x00, 0x41, 0x59, 0x02, 0x00, 0x42, 0x59, 0x02, 0x00, 
    0x45, 0x59, 0x02, 0x00, 0x47, 0x59, 0x02, 0x00, 0x48, 0x59, 0x02, 0x00, 0x56, 0x59, 0x02, 
    0x00, 0x57, 0x59, 0x02, 0x00, 0x60, 0x59, 0x02, 0x00, 0x62, 0x59, 0x02, 0x00, 0x63, 0x59, 
    0x02, 0x00, 0x64, 0x59, 

    0x01, 0x05, 0xff, 0xff, 0x9a, 0x63, 0x08, 0x00, 0xfa, 0x02, 0x00, 0x65, 0x59, 0x02, 0x00, 
    0x84, 0x59, 0x02, 0x00, 0x8c, 0x59, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xb5, 0x43, 0x4d, 0xae, 0x7f, 0x01, 0x24, 0xa6, 
    0x46, 0x3f, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xb0, 0x42, 0xf8, 0xd1, 0x03, 0x20, 0x17, 0x21, 
    0x89, 0x01, 0xa6, 0x46, 0x3b, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xad, 0x7f, 0xa6, 0x46, 0x38, 
    0x48, 0xfe, 0x44, 0x00, 0x47, 0xa8, 0x42, 0xf9, 0xd1, 0xfe, 0xe7, 0xf0, 0xb5, 0x37, 0x49, 
    0x4f, 0x68, 0x33, 0x20, 0xc0, 0x5d, 0xc0, 0x06, 0xc0, 0x0f, 0x84, 0x46, 0x08, 0x78, 0x02, 
    0x28, 0x3e, 0xd1, 0x33, 0x48, 0x06, 0x78, 0x00, 0x24, 0x25, 0x1c, 0x22, 0x1c, 0x1b, 0xe0, 
    0x11, 0x20, 0x40, 0x01, 0x50, 0x43, 0x30, 0x49, 0x0b, 0x18, 0x38, 0x20, 0xc0, 0x5c, 0x00, 
    0x28, 0x0f, 0xd0, 0x18, 0x78, 0xa8, 0x21, 0x41, 0x43, 0x2d, 0x48, 0x41, 0x30, 0x40, 0x5c, 
    0x01, 0x28, 0x07, 0xd0, 0xff, 0x20, 0x1e, 0x30, 0xc0, 0x5c, 0x01, 0x28, 0x01, 0xd1, 0x01, 
    0x25, 0x00, 0xe0, 0x01, 0x24, 0x50, 0x1c, 0x02, 0x06, 0x12, 0x0e, 0xb2, 0x42, 0xe1, 0xdb, 
    0x00, 0x20, 0x00, 0x2d, 

    0x01, 0x05, 0xff, 0xff, 0x94, 0x64, 0x08, 0x00, 0xfa, 0x02, 0xd0, 0x00, 0x2c, 0x00, 0xd1, 
    0x01, 0x20, 0x22, 0x49, 0x0a, 0x78, 0x60, 0x45, 0x10, 0xd0, 0x33, 0x21, 0xcb, 0x19, 0x10, 
    0x24, 0x19, 0x78, 0xa1, 0x43, 0x04, 0x01, 0x10, 0x20, 0x20, 0x40, 0x08, 0x43, 0x18, 0x70, 
    0x19, 0x48, 0x01, 0x2a, 0x00, 0xd1, 0x2c, 0x38, 0x01, 0x21, 0x49, 0x02, 0x01, 0x80, 0xf0, 
    0xbd, 0x70, 0xb5, 0x07, 0x26, 0x15, 0x4d, 0x40, 0x20, 0x40, 0x5d, 0x02, 0x28, 0x0c, 0xd1, 
    0x45, 0x20, 0x40, 0x5d, 0x14, 0x49, 0x08, 0x18, 0x40, 0x00, 0x02, 0x21, 0x01, 0x24, 0xa6, 
    0x46, 0x12, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x28, 0x03, 0xd1, 0xa8, 0x35, 0x01, 0x3e, 
    0xeb, 0xd1, 0x70, 0xbd, 0x0e, 0x48, 0x09, 0x21, 0xa6, 0x46, 0x0e, 0x4a, 0xfe, 0x44, 0x10, 
    0x47, 0x70, 0xbd, 0xc0, 0x46, 0x8b, 0x05, 0x05, 0x00, 0xf5, 0xd3, 0x04, 0x00, 0x8c, 0x4f, 
    0x08, 0x00, 0xe4, 0x21, 0x08, 0x00, 0x83, 0x50, 0x08, 0x00, 0x00, 0x00, 0x08, 0x00, 0x70, 
    0x7c, 0x1a, 0x00, 0x60, 0x19, 0x08, 0x00, 0xe8, 0x57, 0x08, 0x00, 0x11, 0x01, 0x0d, 0x00, 
    0x57, 0x4a, 0x05, 0x00, 0x46, 0x7f, 0x1a, 0x00, 0x61, 0x48, 0x05, 0x00, 0x70, 0xb5, 0x9f, 
    0x48, 0x00, 0x78, 0x01, 0x28, 0x27, 0xd0, 0x00, 0x28, 0x12, 0xd1, 0x9d, 0x4d, 0x28, 0x1c, 
    0x04, 0x21, 0x01, 0x24, 0xa6, 0x46, 0x9b, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x28, 0x2d, 
    0xd1, 0x03, 0x21, 0xc9, 0x01, 0x28, 0x1c, 0x0a, 0x1c, 0xa6, 0x46, 0x97, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0x70, 0xbd, 0x02, 0x28, 0x22, 0xd1, 0x95, 0x48, 0x41, 0x88, 0x09, 0x09, 0x1e, 
    0xd2, 0x41, 0x88, 0x49, 0x08, 0x1b, 0xd2, 0x42, 0x88, 0x10, 0x21, 0x11, 0x43, 0x41, 0x80, 
    0x02, 0x88, 0x01, 0x21, 

    0x01, 0x05, 0xff, 0xff, 0x8e, 0x65, 0x08, 0x00, 0xfa, 0x89, 0x03, 0x11, 0x43, 0x01, 0x80, 
    0x70, 0xbd, 0xe4, 0x4e, 0x30, 0x1c, 0x00, 0x25, 0x29, 0x1c, 0x01, 0x24, 0xa6, 0x46, 0xe3, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0xe0, 0x49, 0x08, 0x80, 0x30, 0x1c, 0x1c, 0x21, 0x2a, 0x1c, 
    0xa6, 0x46, 0xdf, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x70, 0xbd, 0x30, 0xb5, 0xdb, 0x4d, 0x28, 
    0x1c, 0x01, 0x88, 0x7d, 0x48, 0x00, 0x78, 0x01, 0x28, 0x26, 0xd0, 0x00, 0x28, 0x12, 0xd1, 
    0x7b, 0x4d, 0x28, 0x1c, 0x04, 0x21, 0x01, 0x24, 0xa6, 0x46, 0x7a, 0x4a, 0xfe, 0x44, 0x10, 
    0x47, 0x00, 0x28, 0x26, 0xd1, 0x28, 0x1c, 0x00, 0x21, 0x03, 0x22, 0xd2, 0x01, 0xa6, 0x46, 
    0x76, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x30, 0xbd, 0x02, 0x28, 0x1b, 0xd1, 0x74, 0x48, 0x41, 
    0x88, 0x09, 0x09, 0x17, 0xd2, 0x41, 0x88, 0x49, 0x08, 0x14, 0xd2, 0x10, 0x22, 0x41, 0x88, 
    0x91, 0x43, 0x41, 0x80, 0x01, 0x21, 0x89, 0x03, 0x04, 0x88, 0x8c, 0x43, 0x0a, 0xe0, 0xd7, 
    0x4c, 0xa1, 0x42, 0x08, 0xd0, 0xc1, 0x48, 0x00, 0x22, 0x01, 0x23, 0x9e, 0x46, 0xc2, 0x4b, 
    0xfe, 0x44, 0x18, 0x47, 0x28, 0x1c, 0x04, 0x80, 0x30, 0xbd, 0x00, 0xb5, 0x61, 0x49, 0x09, 
    0x78, 0x01, 0x29, 0x08, 0xd1, 0x40, 0x69, 0x00, 0x7a, 0x15, 0x28, 0x04, 0xd1, 0x01, 0x20, 
    0x86, 0x46, 0xe0, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x00, 0xbd, 0xf0, 0xb5, 0x04, 0x69, 0xc7, 
    0x26, 0x30, 0x5d, 0x04, 0x28, 0x24, 0xd1, 0xc8, 0x25, 0x28, 0x5d, 0x18, 0x28, 0x03, 0xd1, 
    0x6a, 0x20, 0x00, 0x5d, 0x04, 0x28, 0x16, 0xd0, 0x28, 0x5d, 0x19, 0x28, 0x19, 0xd1, 0xce, 
    0x20, 0x00, 0x5d, 0x16, 0x28, 0x15, 0xd1, 0xb5, 0x27, 0x38, 0x5d, 0x01, 0x21, 0x8e, 0x46, 
    0xea, 0x4a, 0xfe, 0x44, 

    0x01, 0x05, 0xff, 0xff, 0x88, 0x66, 0x08, 0x00, 0xfa, 0x10, 0x47, 0x00, 0x22, 0x38, 0x5d, 
    0x60, 0x21, 0x41, 0x43, 0xe8, 0x48, 0x42, 0x54, 0x32, 0x55, 0x2a, 0x55, 0xf0, 0xbd, 0x20, 
    0x1c, 0x01, 0x21, 0x8e, 0x46, 0xe5, 0x49, 0xfe, 0x44, 0x08, 0x47, 0xf0, 0xbd, 0xf0, 0xb5, 
    0x06, 0x1c, 0xb5, 0x69, 0xb4, 0x8a, 0x42, 0x48, 0x02, 0x78, 0x00, 0x27, 0xe0, 0x49, 0xe1, 
    0x48, 0x8c, 0x42, 0x0e, 0xdc, 0xe0, 0x4a, 0x8c, 0x42, 0x51, 0xd0, 0x71, 0x39, 0x61, 0x1a, 
    0x57, 0xd0, 0x01, 0x39, 0x4c, 0xd0, 0x43, 0x39, 0x34, 0xd0, 0x29, 0x39, 0x51, 0xd0, 0x01, 
    0x39, 0x57, 0xd0, 0xf0, 0xbd, 0x48, 0x31, 0x61, 0x1a, 0x23, 0xd0, 0x0b, 0x39, 0x34, 0xd0, 
    0x01, 0x39, 0x14, 0xd0, 0x01, 0x39, 0x64, 0xd1, 0xe1, 0x48, 0x00, 0x78, 0x02, 0x28, 0x2a, 
    0xd1, 0xe8, 0x7a, 0x00, 0x07, 0x00, 0x0f, 0xdf, 0x49, 0x0a, 0x1c, 0xb6, 0x3a, 0x10, 0x70, 
    0x02, 0x01, 0x02, 0x43, 0x12, 0x01, 0x02, 0x43, 0x12, 0x01, 0x02, 0x43, 0x0a, 0x80, 0x20, 
    0xe0, 0x01, 0x2a, 0x01, 0xd0, 0x04, 0x2a, 0x1c, 0xd1, 0x28, 0x1c, 0x01, 0x21, 0x8e, 0x46, 
    0xe8, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x15, 0xe0, 0x0e, 0x21, 0x01, 0x22, 0x96, 0x46, 0xe6, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0x01, 0x28, 0x08, 0xd0, 0xf0, 0xbd, 0x0d, 0x21, 0x01, 0x22, 
    0x96, 0x46, 0xe1, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x01, 0x28, 0x35, 0xd1, 0x0c, 0x27, 0x02, 
    0xe0, 0xe8, 0x7a, 0xde, 0x49, 0x08, 0x70, 0x28, 0x1c, 0x21, 0x1c, 0x3a, 0x1c, 0x01, 0x23, 
    0x9e, 0x46, 0xdc, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x24, 0xe0, 0x10, 0x1c, 0x39, 0x1c, 0x06, 
    0x22, 0x01, 0x23, 0x9e, 0x46, 0xf0, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xf0, 0xbd, 0x10, 0x1c, 
    0x03, 0x21, 0x06, 0x22, 

    0x01, 0x05, 0xff, 0xff, 0x82, 0x67, 0x08, 0x00, 0xfa, 0x01, 0x23, 0x9e, 0x46, 0xec, 0x4b, 
    0xfe, 0x44, 0x18, 0x47, 0xeb, 0x48, 0x00, 0x68, 0x00, 0x28, 0x12, 0xd0, 0x04, 0x20, 0x01, 
    0x24, 0xa6, 0x46, 0xe9, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x47, 0x21, 0x09, 0x02, 0x01, 0x80, 
    0x85, 0x80, 0x29, 0x0c, 0xc1, 0x80, 0xa6, 0x46, 0xe5, 0x49, 0xfe, 0x44, 0x08, 0x47, 0xdf, 
    0x48, 0x9e, 0x30, 0x30, 0x62, 0xf0, 0xbd, 0xe8, 0x57, 0x08, 0x00, 0x7e, 0x7c, 0x1a, 0x00, 
    0x43, 0x4a, 0x05, 0x00, 0xdb, 0x4a, 0x05, 0x00, 0x60, 0x7a, 0x1a, 0x00, 0xf8, 0xb5, 0x06, 
    0x1c, 0xb5, 0x69, 0xb0, 0x8a, 0xdb, 0x49, 0x40, 0x1a, 0x00, 0xd1, 0x99, 0xe0, 0x65, 0x49, 
    0x89, 0x09, 0x40, 0x1a, 0x69, 0xd0, 0xd8, 0x49, 0x40, 0x1a, 0xa2, 0x49, 0x25, 0xd0, 0x07, 
    0x38, 0x00, 0xd0, 0x96, 0xe0, 0x0e, 0x20, 0x40, 0x19, 0x06, 0x22, 0xaa, 0x80, 0x08, 0x22, 
    0x6a, 0x80, 0x09, 0x78, 0x02, 0x29, 0x0c, 0xd1, 0xd1, 0x49, 0x01, 0x24, 0xa6, 0x46, 0xd1, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x21, 0xa6, 0x46, 0xce, 0x4a, 0xfe, 0x44, 0x10, 0x47, 
    0x00, 0x22, 0x00, 0xe0, 0x0c, 0x22, 0x28, 0x1c, 0x87, 0x21, 0x89, 0x00, 0x01, 0x23, 0x9e, 
    0x46, 0xca, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xc9, 0x48, 0xfa, 0x30, 0x30, 0x62, 0xf8, 0xbd, 
    0x08, 0x78, 0x02, 0x28, 0x33, 0xd1, 0x0b, 0x20, 0x40, 0x19, 0x01, 0x24, 0xa6, 0x46, 0xef, 
    0x49, 0xfe, 0x44, 0x08, 0x47, 0x00, 0x90, 0xa6, 0x46, 0xc2, 0x49, 0xfe, 0x44, 0x08, 0x47, 
    0x00, 0x06, 0x00, 0x0e, 0xa6, 0x46, 0xc0, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x07, 0x1c, 0x0e, 
    0x20, 0x40, 0x19, 0x00, 0x99, 0xa6, 0x46, 0xed, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x06, 0x21, 
    0xa9, 0x80, 0x07, 0x21, 

    0x01, 0x05, 0xff, 0xff, 0x7c, 0x68, 0x08, 0x00, 0xfa, 0x69, 0x80, 0x00, 0x2f, 0x0b, 0xd0, 
    0x00, 0x99, 0xc9, 0x0a, 0x08, 0xd3, 0x3a, 0x21, 0xc9, 0x19, 0x05, 0x22, 0xa6, 0x46, 0xe6, 
    0x4b, 0xfe, 0x44, 0x18, 0x47, 0x00, 0x22, 0x08, 0xe0, 0x00, 0x21, 0x05, 0x22, 0xa6, 0x46, 
    0xe3, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x02, 0x22, 0x00, 0xe0, 0x0c, 0x22, 0x28, 0x1c, 0xe1, 
    0x49, 0x01, 0x23, 0x9e, 0x46, 0xe0, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xbb, 0xe7, 0x2f, 0x1c, 
    0x06, 0x20, 0xa8, 0x80, 0x0e, 0x20, 0x40, 0x19, 0x40, 0x21, 0x01, 0x24, 0xa6, 0x46, 0xea, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0xea, 0x48, 0x01, 0x1c, 0xcf, 0x22, 0x0a, 0x72, 0x08, 0x31, 
    0x61, 0x22, 0x0a, 0x74, 0x19, 0x21, 0x02, 0x78, 0xba, 0x73, 0x01, 0x37, 0x01, 0x30, 0x01, 
    0x39, 0xf9, 0xd1, 0x04, 0x20, 0xe3, 0x49, 0x0a, 0x78, 0xba, 0x73, 0x01, 0x37, 0x01, 0x31, 
    0x01, 0x38, 0xf9, 0xd1, 0x40, 0x20, 0x68, 0x80, 0x28, 0x1c, 0x81, 0x21, 0x49, 0x00, 0x00, 
    0x22, 0xa6, 0x46, 0x92, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x8f, 0xe7, 0x4b, 0x48, 0x00, 0x21, 
    0x06, 0x22, 0x01, 0x23, 0x9e, 0x46, 0x86, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xf8, 0xbd, 0xc0, 
    0x46, 0x58, 0x74, 0x1a, 0x00, 0xb0, 0x63, 0x08, 0x00, 0x6b, 0x4a, 0x05, 0x00, 0x15, 0x49, 
    0x05, 0x00, 0x30, 0xb5, 0x05, 0x1c, 0xeb, 0x48, 0x00, 0x78, 0x00, 0x28, 0x17, 0xd1, 0x01, 
    0x24, 0xa6, 0x46, 0xe9, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x00, 0x28, 0x0b, 0xd1, 0xa6, 0x46, 
    0xe7, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x01, 0x28, 0x05, 0xd0, 0xa6, 0x46, 0xe5, 0x48, 0xfe, 
    0x44, 0x00, 0x47, 0x01, 0x28, 0x04, 0xd1, 0x00, 0x20, 0x28, 0x60, 0xe3, 0x48, 0x52, 0x30, 
    0x28, 0x62, 0x30, 0xbd, 

    0x01, 0x05, 0xff, 0xff, 0x76, 0x69, 0x08, 0x00, 0xfa, 0xc0, 0x46, 0xff, 0xff, 0x00, 0x00, 
    0x70, 0xb5, 0xe9, 0x49, 0x80, 0x8a, 0x88, 0x42, 0x20, 0xd1, 0xe8, 0x4b, 0xe8, 0x4a, 0x00, 
    0x21, 0x40, 0x20, 0x80, 0x5c, 0x00, 0x28, 0x0e, 0xd0, 0x18, 0x78, 0xe6, 0x4e, 0x8c, 0x00, 
    0xe6, 0x4d, 0x2c, 0x19, 0x25, 0x6a, 0xb5, 0x42, 0x0b, 0xd8, 0x64, 0x68, 0xb4, 0x42, 0x08, 
    0xd8, 0x01, 0x24, 0x8c, 0x40, 0xa0, 0x43, 0x18, 0x70, 0xa8, 0x32, 0x01, 0x31, 0x07, 0x29, 
    0xe8, 0xdb, 0x70, 0xbd, 0x0a, 0x06, 0x12, 0x0e, 0x01, 0x21, 0x91, 0x40, 0x01, 0x43, 0x19, 
    0x70, 0x70, 0xbd, 0xc0, 0x46, 0xe7, 0x46, 0x04, 0x00, 0x70, 0xb5, 0x05, 0x1c, 0xae, 0x69, 
    0x47, 0x20, 0x00, 0x02, 0x31, 0x88, 0x09, 0x12, 0x09, 0x02, 0x81, 0x42, 0x23, 0xd1, 0x55, 
    0x48, 0x00, 0x68, 0x00, 0x28, 0x0e, 0xd1, 0xf0, 0x88, 0x00, 0x04, 0xb1, 0x88, 0x08, 0x43, 
    0x01, 0x24, 0xa6, 0x46, 0x4e, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x30, 0x1c, 0xa6, 0x46, 0xcd, 
    0x49, 0xfe, 0x44, 0x08, 0x47, 0x0b, 0xe0, 0x7d, 0x20, 0xc0, 0x00, 0x01, 0x24, 0xa6, 0x46, 
    0xcb, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x30, 0x1c, 0xa6, 0x46, 0x49, 0x49, 0xfe, 0x44, 0x08, 
    0x47, 0xc6, 0x49, 0x05, 0x20, 0x00, 0x02, 0x40, 0x18, 0x28, 0x62, 0x70, 0xbd, 0xc0, 0x46, 
    0xc9, 0xa2, 0x00, 0x00, 0x76, 0xa0, 0x1b, 0x00, 0x6d, 0x97, 0x00, 0x00, 0x88, 0xfd, 0x00, 
    0x00, 0xc0, 0x61, 0x1a, 0x00, 0x6a, 0x0a, 0x1a, 0x00, 0x70, 0xb5, 0x05, 0x1c, 0x6e, 0x69, 
    0x20, 0x48, 0x00, 0x78, 0x01, 0x28, 0x0f, 0xd1, 0x03, 0x20, 0xbb, 0x49, 0x03, 0x39, 0x01, 
    0x24, 0xa6, 0x46, 0xba, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x30, 0x1c, 0xa6, 0x46, 0xb3, 0x49, 
    0xfe, 0x44, 0x08, 0x47, 

    0x01, 0x05, 0xff, 0xff, 0x70, 0x6a, 0x08, 0x00, 0xfa, 0xb4, 0x48, 0x1a, 0x30, 0x28, 0x62, 
    0x70, 0xbd, 0x41, 0x10, 0x08, 0x00, 0x4c, 0xa6, 0x1b, 0x00, 0x30, 0xb5, 0x04, 0x1c, 0xa1, 
    0x69, 0x00, 0x29, 0x1c, 0xd0, 0x20, 0x69, 0x02, 0x78, 0xff, 0x2a, 0x18, 0xd0, 0x8a, 0x88, 
    0x89, 0x18, 0x08, 0x22, 0xca, 0x42, 0x13, 0xd0, 0x39, 0x22, 0x12, 0x5c, 0x0a, 0x2a, 0x0f, 
    0xd1, 0x09, 0x7a, 0x4a, 0x08, 0x0f, 0x2a, 0x0b, 0xd1, 0xc9, 0x07, 0xc9, 0x0f, 0x0f, 0x22, 
    0x2a, 0x23, 0x01, 0x25, 0xae, 0x46, 0xa5, 0x4d, 0xfe, 0x44, 0x28, 0x47, 0xa5, 0x48, 0xf0, 
    0x30, 0x20, 0x62, 0x30, 0xbd, 0xc0, 0x46, 0x81, 0x08, 0x18, 0x00, 0x2f, 0x4a, 0x05, 0x00, 
    0xfb, 0x63, 0x08, 0x00, 0x99, 0x77, 0x05, 0x00, 0x70, 0xb5, 0x85, 0xb0, 0x05, 0x1c, 0x68, 
    0x69, 0x9d, 0x4e, 0x01, 0x24, 0x34, 0x70, 0x01, 0x7a, 0x89, 0x06, 0x09, 0x0e, 0x9b, 0x4a, 
    0x52, 0x58, 0x69, 0x46, 0xa6, 0x46, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x20, 0x30, 0x70, 0x68, 
    0x46, 0x01, 0x7c, 0x6e, 0x46, 0x72, 0x7c, 0x14, 0x20, 0xa6, 0x46, 0x95, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0x68, 0x46, 0x01, 0x7c, 0x06, 0x29, 0x04, 0xd0, 0xa6, 0x46, 0x92, 0x49, 0xfe, 
    0x44, 0x08, 0x47, 0x04, 0xe0, 0x91, 0x4a, 0x34, 0x21, 0x88, 0x5c, 0x01, 0x30, 0x88, 0x54, 
    0x90, 0x48, 0x4e, 0x30, 0x28, 0x62, 0x05, 0xb0, 0x70, 0xbd, 0x81, 0x60, 0x00, 0x00, 0x91, 
    0x48, 0x05, 0x00, 0x2c, 0x51, 0x08, 0x00, 0x9b, 0x60, 0x04, 0x00, 0xe9, 0x3f, 0x05, 0x00, 
    0x03, 0x0c, 0x00, 0x00, 0x13, 0x10, 0x00, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x53, 0x2c, 0x00, 
    0x00, 0xc1, 0x50, 0x02, 0x00, 0x25, 0x00, 0x00, 0x00, 0x71, 0x8b, 0x04, 0x00, 0x9b, 0x8b, 
    0x04, 0x00, 0xf0, 0xb5, 

    0x01, 0x05, 0xff, 0xff, 0x6a, 0x6b, 0x08, 0x00, 0xfa, 0x05, 0x1c, 0x6c, 0x69, 0x2e, 0x69, 
    0x28, 0x7f, 0x17, 0x21, 0x40, 0x1a, 0x0f, 0xd0, 0x0d, 0x38, 0x53, 0xd1, 0x01, 0x24, 0xa6, 
    0x46, 0x7b, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xa6, 0x46, 0x7a, 0x49, 0xfe, 0x44, 0x08, 0x47, 
    0x00, 0x28, 0x48, 0xd0, 0x7a, 0x48, 0xb2, 0x38, 0x42, 0xe0, 0xff, 0x20, 0x7d, 0x30, 0x07, 
    0x19, 0x30, 0x78, 0x38, 0x70, 0x39, 0x78, 0x02, 0x20, 0x08, 0x40, 0x38, 0x70, 0x01, 0x36, 
    0x30, 0x1c, 0x01, 0x21, 0x8e, 0x46, 0x15, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x78, 0x80, 0x02, 
    0x36, 0x30, 0x1c, 0x01, 0x21, 0x8e, 0x46, 0x11, 0x49, 0xfe, 0x44, 0x08, 0x47, 0xb8, 0x80, 
    0xff, 0x20, 0x83, 0x30, 0x04, 0x19, 0x02, 0x36, 0x30, 0x1c, 0x01, 0x21, 0x8e, 0x46, 0x0b, 
    0x49, 0xfe, 0x44, 0x08, 0x47, 0x20, 0x80, 0x02, 0x36, 0x30, 0x1c, 0x01, 0x21, 0x8e, 0x46, 
    0x07, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x60, 0x80, 0xb8, 0x88, 0x79, 0x88, 0x01, 0x43, 0x49, 
    0x08, 0x10, 0xd2, 0x21, 0x88, 0x00, 0x29, 0x0d, 0xd0, 0x42, 0x08, 0x91, 0x42, 0x0a, 0xdc, 
    0x01, 0xe0, 0x73, 0x2c, 0x00, 0x00, 0x08, 0x28, 0x02, 0xda, 0xff, 0xe7, 0x5a, 0x48, 0x03, 
    0xe0, 0x59, 0x48, 0x12, 0x30, 0x00, 0xe0, 0x58, 0x48, 0x56, 0x49, 0x40, 0x18, 0x28, 0x62, 
    0xf0, 0xbd, 0xc0, 0x46, 0x69, 0x2c, 0x00, 0x00, 0x21, 0xa7, 0x05, 0x00, 0xc1, 0xad, 0x05, 
    0x00, 0x15, 0x20, 0x00, 0x00, 0xa7, 0x50, 0x02, 0x00, 0x10, 0xb5, 0x56, 0x48, 0x00, 0x78, 
    0x01, 0x28, 0x01, 0xd0, 0x04, 0x28, 0x08, 0xd1, 0x01, 0x24, 0xa6, 0x46, 0x4d, 0x48, 0xfe, 
    0x44, 0x00, 0x47, 0xa6, 0x46, 0x4c, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x01, 0x24, 0xa6, 0x46, 
    0x4a, 0x48, 0xfe, 0x44, 

    0x01, 0x05, 0xff, 0xff, 0x64, 0x6c, 0x08, 0x00, 0xfa, 0x00, 0x47, 0xa6, 0x46, 0x49, 0x48, 
    0xfe, 0x44, 0x00, 0x47, 0xa6, 0x46, 0x48, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x10, 0xbd, 0x91, 
    0x1c, 0x04, 0x00, 0xb3, 0x11, 0x08, 0x00, 0xf0, 0x63, 0x08, 0x00, 0x10, 0xb5, 0x45, 0x4c, 
    0x45, 0x48, 0x00, 0x78, 0x21, 0x78, 0x81, 0x42, 0x0d, 0xdd, 0x07, 0x21, 0x43, 0x48, 0x00, 
    0x22, 0x40, 0x23, 0x1b, 0x5c, 0x00, 0x2b, 0x02, 0xd0, 0x52, 0x1c, 0x12, 0x06, 0x12, 0x0e, 
    0xa8, 0x30, 0x01, 0x39, 0xf5, 0xd1, 0x22, 0x70, 0x10, 0xbd, 0xf0, 0xb5, 0x01, 0x24, 0xa6, 
    0x46, 0x2e, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xa6, 0x46, 0x2d, 0x49, 0xfe, 0x44, 0x08, 0x47, 
    0x00, 0x28, 0x10, 0xd0, 0x11, 0x27, 0x09, 0x26, 0x36, 0x4d, 0x3e, 0x20, 0x40, 0x5d, 0xff, 
    0x28, 0x06, 0xd0, 0x3b, 0x20, 0x47, 0x55, 0x28, 0x1c, 0xa6, 0x46, 0x33, 0x49, 0xfe, 0x44, 
    0x08, 0x47, 0x50, 0x35, 0x01, 0x3e, 0xf1, 0xd1, 0xf0, 0xbd, 0xef, 0x22, 0x08, 0x00, 0x5d, 
    0x8b, 0x04, 0x00, 0x7b, 0x5f, 0x03, 0x00, 0xab, 0xb9, 0x03, 0x00, 0xbf, 0x70, 0x05, 0x00, 
    0x00, 0xb5, 0x2b, 0x48, 0x00, 0x88, 0x02, 0x28, 0x01, 0xda, 0x01, 0x21, 0x02, 0xe0, 0x40, 
    0x1e, 0x01, 0x04, 0x09, 0x0c, 0x27, 0x48, 0x00, 0x22, 0x01, 0x23, 0x9e, 0x46, 0x26, 0x4b, 
    0xfe, 0x44, 0x18, 0x47, 0x00, 0xbd, 0x76, 0x81, 0x00, 0x00, 0xb5, 0x63, 0x08, 0x00, 0x60, 
    0x19, 0x08, 0x00, 0x10, 0x27, 0x00, 0x00, 0xcc, 0x24, 0x08, 0x00, 0x2d, 0x61, 0x04, 0x00, 
    0xd5, 0xb4, 0x02, 0x00, 0xbb, 0x16, 0x04, 0x00, 0x5d, 0xf0, 0x03, 0x00, 0xae, 0x05, 0x00, 
    0x00, 0xf5, 0xd3, 0x04, 0x00, 0x55, 0xf6, 0x00, 0x00, 0x5b, 0xf5, 0x00, 0x00, 0xfc, 0x63, 
    0x08, 0x00, 0xb4, 0x8a, 

    0x01, 0x05, 0xff, 0xff, 0x5e, 0x6d, 0x08, 0x00, 0xfa, 0x06, 0x00, 0xa9, 0xd3, 0x04, 0x00, 
    0x61, 0x97, 0x04, 0x00, 0x28, 0x19, 0x08, 0x00, 0x57, 0x98, 0x04, 0x00, 0x37, 0x98, 0x01, 
    0x00, 0x37, 0x9b, 0x01, 0x00, 0x0d, 0xe2, 0x00, 0x00, 0xca, 0x0c, 0x00, 0x00, 0x3a, 0x0e, 
    0x00, 0x00, 0x33, 0x64, 0x08, 0x00, 0xc9, 0x64, 0x08, 0x00, 0xb1, 0x6c, 0x08, 0x00, 0x01, 
    0x6d, 0x08, 0x00, 0x85, 0x6c, 0x08, 0x00, 0xe8, 0x57, 0x08, 0x00, 0xbf, 0x0f, 0x08, 0x00, 
    0x83, 0x50, 0x08, 0x00, 0x60, 0x19, 0x08, 0x00, 0xf4, 0x46, 0x08, 0x00, 0xa5, 0x1e, 0x02, 
    0x00, 0x8c, 0x18, 0x08, 0x00, 0x36, 0x02, 0x1a, 0x00, 0x15, 0x49, 0x05, 0x00, 0xf0, 0xb5, 
    0x87, 0xb0, 0x06, 0x1c, 0xf0, 0x4d, 0x28, 0x78, 0x01, 0x28, 0x02, 0xd1, 0x01, 0x27, 0xff, 
    0x03, 0x01, 0xe0, 0x7d, 0x27, 0x3f, 0x02, 0xed, 0x48, 0x00, 0x21, 0x01, 0x24, 0xa6, 0x46, 
    0xd5, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xe9, 0x49, 0x48, 0x43, 0x39, 0x1c, 0xa6, 0x46, 0xe9, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0x01, 0x91, 0x28, 0x78, 0x01, 0x28, 0x02, 0xd1, 0x01, 0x21, 
    0xc9, 0x03, 0x01, 0xe0, 0x7d, 0x21, 0x09, 0x02, 0xee, 0x48, 0xa6, 0x46, 0xe2, 0x4a, 0xfe, 
    0x44, 0x10, 0x47, 0x02, 0x91, 0x76, 0x69, 0xf0, 0x7a, 0x03, 0x90, 0x30, 0x1c, 0x21, 0x1c, 
    0xa6, 0x46, 0xf2, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x04, 0x90, 0x30, 0x1c, 0x05, 0x21, 0xa6, 
    0x46, 0xee, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x05, 0x90, 0x30, 0x7f, 0x06, 0x90, 0xf7, 0x7e, 
    0x00, 0x97, 0x06, 0x9b, 0x03, 0x20, 0xf1, 0x49, 0xde, 0x31, 0x04, 0x9a, 0xa6, 0x46, 0xe8, 
    0x4e, 0xfe, 0x44, 0x30, 0x47, 0x03, 0x98, 0xff, 0x28, 0x04, 0xd0, 0x03, 0x98, 0xa6, 0x46, 
    0xe5, 0x49, 0xfe, 0x44, 

    0x01, 0x05, 0xff, 0xff, 0x58, 0x6e, 0x08, 0x00, 0xfa, 0x08, 0x47, 0x04, 0x98, 0x40, 0x1c, 
    0x07, 0xd0, 0x04, 0x98, 0x03, 0x99, 0x06, 0x9a, 0x3b, 0x1c, 0xa6, 0x46, 0xe1, 0x4e, 0xfe, 
    0x44, 0x30, 0x47, 0xe5, 0x48, 0x00, 0x78, 0x02, 0x28, 0x00, 0xd0, 0xb2, 0xe0, 0x28, 0x78, 
    0xdd, 0x4e, 0x01, 0x2f, 0x52, 0xd0, 0xb1, 0x89, 0x01, 0x28, 0x02, 0xd1, 0x01, 0x20, 0xc0, 
    0x03, 0x01, 0xe0, 0x7d, 0x20, 0x00, 0x02, 0x04, 0x99, 0x48, 0x43, 0xd8, 0x49, 0x08, 0x18, 
    0xbb, 0x49, 0xa6, 0x46, 0xd7, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xb1, 0x81, 0x28, 0x78, 0x01, 
    0x28, 0x02, 0xd1, 0x01, 0x20, 0xc0, 0x03, 0x01, 0xe0, 0x7d, 0x20, 0x00, 0x02, 0xd2, 0x4d, 
    0x0f, 0x27, 0x29, 0x88, 0x39, 0x40, 0x2a, 0x88, 0x12, 0x09, 0x3a, 0x40, 0x8a, 0x42, 0x04, 
    0xdd, 0x29, 0x88, 0x09, 0x11, 0x09, 0x07, 0x0f, 0x0f, 0x01, 0xe0, 0x29, 0x88, 0x0f, 0x40, 
    0x04, 0x99, 0x41, 0x43, 0xc7, 0x48, 0x40, 0x18, 0xaa, 0x49, 0xa6, 0x46, 0xc6, 0x4a, 0xfe, 
    0x44, 0x10, 0x47, 0x30, 0x1c, 0x9c, 0x30, 0x00, 0x88, 0x1f, 0x22, 0x10, 0x40, 0x40, 0x18, 
    0xa9, 0x89, 0x11, 0x40, 0x08, 0x18, 0x31, 0x8a, 0x08, 0x18, 0xe4, 0x49, 0x09, 0x88, 0x09, 
    0x0a, 0x08, 0x18, 0xe2, 0x49, 0x09, 0x89, 0x09, 0x0a, 0x08, 0x18, 0x39, 0x18, 0x06, 0x98, 
    0x40, 0x18, 0x05, 0x30, 0x01, 0x04, 0x09, 0x0c, 0x9c, 0x48, 0x00, 0x22, 0xa6, 0x46, 0xed, 
    0x4b, 0xfe, 0x44, 0x18, 0x47, 0x50, 0xe0, 0x31, 0x88, 0x01, 0x28, 0x02, 0xd1, 0x01, 0x20, 
    0xc0, 0x03, 0x01, 0xe0, 0x7d, 0x20, 0x00, 0x02, 0x04, 0x99, 0x48, 0x43, 0xae, 0x49, 0x08, 
    0x18, 0x91, 0x49, 0xa6, 0x46, 0xad, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x31, 0x80, 0x28, 0x78, 
    0x01, 0x28, 0x02, 0xd1, 

    0x01, 0x05, 0xff, 0xff, 0x52, 0x6f, 0x08, 0x00, 0xfa, 0x01, 0x20, 0xc0, 0x03, 0x01, 0xe0, 
    0x7d, 0x20, 0x00, 0x02, 0xa8, 0x4d, 0x0f, 0x27, 0xa9, 0x88, 0x09, 0x09, 0x39, 0x40, 0xaa, 
    0x88, 0x3a, 0x40, 0x8a, 0x42, 0x03, 0xdd, 0xa9, 0x88, 0x09, 0x07, 0x0f, 0x0f, 0x02, 0xe0, 
    0xa9, 0x88, 0x09, 0x09, 0x0f, 0x40, 0x04, 0x99, 0x41, 0x43, 0x9d, 0x48, 0x40, 0x18, 0x80, 
    0x49, 0xa6, 0x46, 0x9c, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x30, 0x89, 0x1f, 0x22, 0x10, 0x40, 
    0x40, 0x18, 0xb1, 0x88, 0x11, 0x40, 0x08, 0x18, 0x29, 0x89, 0x11, 0x40, 0x08, 0x18, 0xbb, 
    0x49, 0x09, 0x88, 0x09, 0x0a, 0x08, 0x18, 0xb9, 0x49, 0x09, 0x89, 0x09, 0x0a, 0x08, 0x18, 
    0x39, 0x18, 0x06, 0x98, 0x40, 0x18, 0x05, 0x30, 0x01, 0x04, 0x09, 0x0c, 0x73, 0x48, 0x00, 
    0x22, 0xa6, 0x46, 0xc4, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x01, 0x98, 0x02, 0x99, 0x41, 0x18, 
    0x8c, 0x48, 0x40, 0x18, 0xde, 0x49, 0xa6, 0x46, 0x88, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x07, 
    0xe0, 0x88, 0x48, 0x01, 0x99, 0x40, 0x18, 0xda, 0x49, 0xa6, 0x46, 0x84, 0x4a, 0xfe, 0x44, 
    0x10, 0x47, 0xc8, 0x1c, 0xd6, 0x49, 0x08, 0x80, 0xd7, 0x48, 0x05, 0x99, 0x49, 0x1c, 0x01, 
    0xd0, 0x59, 0x30, 0x00, 0xe0, 0x61, 0x30, 0x07, 0xb0, 0xf0, 0xbd, 0x70, 0xb5, 0x06, 0x1c, 
    0x01, 0x25, 0xae, 0x46, 0xeb, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xeb, 0x48, 0xae, 0x46, 0xeb, 
    0x49, 0xfe, 0x44, 0x08, 0x47, 0xea, 0x48, 0x00, 0x78, 0xea, 0x4c, 0x00, 0x28, 0x04, 0xd1, 
    0xae, 0x46, 0xe9, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x03, 0xe0, 0xae, 0x46, 0xe8, 0x49, 0xfe, 
    0x44, 0x08, 0x47, 0x60, 0x62, 0x74, 0x61, 0x60, 0x6a, 0x70, 0x60, 0xe5, 0x48, 0x4f, 0x30, 
    0x70, 0xbd, 0xc0, 0x1e, 

    0x01, 0x05, 0xff, 0xff, 0x4c, 0x70, 0x08, 0x00, 0xfa, 0x02, 0xd0, 0x02, 0x38, 0x02, 0xd0, 
    0x03, 0xe0, 0xe2, 0x48, 0xf7, 0x46, 0xe2, 0x48, 0xf7, 0x46, 0x00, 0x20, 0xc0, 0x43, 0xf7, 
    0x46, 0xf0, 0xb5, 0xc2, 0x69, 0x11, 0x06, 0x09, 0x0e, 0xd9, 0x4c, 0x27, 0x68, 0x66, 0x4b, 
    0x1b, 0x78, 0xdd, 0x4e, 0x02, 0x2b, 0x03, 0xd0, 0x42, 0x60, 0x30, 0x1c, 0x51, 0x30, 0xf0, 
    0xbd, 0x08, 0x1c, 0x01, 0x25, 0xae, 0x46, 0xea, 0x49, 0xfe, 0x44, 0x08, 0x47, 0xe1, 0x69, 
    0xd4, 0x48, 0x02, 0x1c, 0x52, 0x00, 0x91, 0x42, 0x01, 0xd0, 0x81, 0x42, 0x1e, 0xd1, 0xa0, 
    0x6a, 0xeb, 0x49, 0x88, 0x42, 0x04, 0xd0, 0xea, 0x49, 0x88, 0x42, 0x03, 0xd1, 0xea, 0x48, 
    0x00, 0xe0, 0xea, 0x48, 0x20, 0x60, 0x36, 0x48, 0x1a, 0x30, 0x0c, 0x21, 0xae, 0x46, 0xe9, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0x41, 0x1c, 0x20, 0x68, 0xae, 0x46, 0x4d, 0x4a, 0xfe, 0x44, 
    0x10, 0x47, 0x21, 0x61, 0xae, 0x46, 0xe2, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x27, 0x60, 0x03, 
    0xe0, 0xae, 0x46, 0xdf, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x30, 0x1c, 0x59, 0x30, 0xf0, 0xbd, 
    0x40, 0x1e, 0x80, 0x00, 0xde, 0x4b, 0x19, 0x50, 0xdc, 0x49, 0x0a, 0x50, 0xf7, 0x46, 0x80, 
    0x69, 0xb8, 0x21, 0x09, 0x5c, 0x01, 0x29, 0x06, 0xd0, 0xb5, 0x21, 0x08, 0x5c, 0x60, 0x21, 
    0x41, 0x43, 0xd8, 0x4a, 0x00, 0x20, 0x50, 0x54, 0xd8, 0x48, 0x1b, 0x30, 0xf7, 0x46, 0x10, 
    0xb5, 0x04, 0x1c, 0xd6, 0x48, 0x00, 0x68, 0x01, 0x21, 0x8e, 0x46, 0xd5, 0x49, 0xfe, 0x44, 
    0x08, 0x47, 0xe0, 0x68, 0x0c, 0x30, 0xe0, 0x60, 0xd3, 0x48, 0xff, 0x30, 0x02, 0x30, 0x10, 
    0xbd, 0xa7, 0x4a, 0x05, 0x00, 0x30, 0xb5, 0x42, 0x69, 0x11, 0x88, 0x09, 0x06, 0x0b, 0x0e, 
    0xcf, 0x49, 0x02, 0x2b, 

    0x01, 0x05, 0xff, 0xff, 0x46, 0x71, 0x08, 0x00, 0xfa, 0x1a, 0xd1, 0xca, 0x4b, 0x1b, 0x6b, 
    0x9b, 0x68, 0xdb, 0x88, 0x01, 0x24, 0xa4, 0x02, 0x1d, 0x05, 0xad, 0x0f, 0xad, 0x02, 0xa5, 
    0x42, 0x06, 0xdb, 0x05, 0x24, 0x24, 0x02, 0x1b, 0x05, 0x1b, 0x0f, 0x1b, 0x02, 0xa3, 0x42, 
    0x02, 0xdb, 0xd2, 0x88, 0x52, 0x1d, 0x01, 0xe0, 0x52, 0x88, 0x52, 0x1c, 0x42, 0x60, 0x08, 
    0x1c, 0x9f, 0x30, 0x30, 0xbd, 0x08, 0x1c, 0x87, 0x30, 0x30, 0xbd, 0x5e, 0x56, 0x08, 0x00, 
    0x40, 0x42, 0x0f, 0x00, 0x04, 0x60, 0x1a, 0x00, 0x6d, 0x94, 0x05, 0x00, 0x00, 0xb5, 0x01, 
    0x1c, 0x48, 0x68, 0xc9, 0x69, 0xb5, 0x22, 0x51, 0x5c, 0xdc, 0x22, 0x4a, 0x43, 0xea, 0x49, 
    0x89, 0x18, 0x08, 0x22, 0x01, 0x23, 0x9e, 0x46, 0xe9, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xe8, 
    0x48, 0x3f, 0x30, 0x00, 0xbd, 0xc0, 0x46, 0x80, 0xc3, 0xc9, 0x01, 0x40, 0x69, 0x01, 0x8f, 
    0xc0, 0x8e, 0x40, 0x1a, 0x00, 0x04, 0x02, 0x0c, 0xe9, 0x49, 0x49, 0x0a, 0x0c, 0x48, 0x8a, 
    0x42, 0x01, 0xd3, 0xfa, 0x38, 0x00, 0xe0, 0xa2, 0x30, 0xe4, 0x49, 0x40, 0x18, 0xf7, 0x46, 
    0xc0, 0x46, 0xe5, 0x2b, 0x00, 0x00, 0x19, 0xd4, 0x04, 0x00, 0x81, 0x42, 0x02, 0x00, 0x55, 
    0x3f, 0x02, 0x00, 0xc0, 0x79, 0x1a, 0x00, 0x3f, 0x42, 0x0f, 0x00, 0x05, 0x9a, 0x05, 0x00, 
    0x28, 0x79, 0x1a, 0x00, 0xe1, 0x04, 0x00, 0x00, 0xe8, 0x57, 0x08, 0x00, 0xf8, 0xb5, 0x81, 
    0x69, 0x08, 0x04, 0x00, 0x0c, 0x00, 0x90, 0xd9, 0x4d, 0xda, 0x4c, 0xc8, 0x08, 0x2a, 0xd3, 
    0xd6, 0x48, 0xff, 0x21, 0x3d, 0x31, 0x0f, 0x18, 0x29, 0x5c, 0x00, 0x26, 0x21, 0xe0, 0xa8, 
    0x00, 0x30, 0x58, 0xc2, 0x22, 0x12, 0x5c, 0x00, 0x2a, 0x0a, 0xd0, 0xb5, 0x21, 0x08, 0x5c, 
    0x0a, 0x30, 0x00, 0x06, 

    0x01, 0x05, 0xff, 0xff, 0x40, 0x72, 0x08, 0x00, 0xfa, 0x00, 0x0e, 0x01, 0x21, 0x8e, 0x46, 
    0xce, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x21, 0x78, 0x01, 0x35, 0x19, 0xe0, 0xb0, 0x00, 0x38, 
    0x58, 0xc2, 0x22, 0x12, 0x5c, 0x00, 0x2a, 0x07, 0xd0, 0xb5, 0x21, 0x08, 0x5c, 0x01, 0x21, 
    0x8e, 0x46, 0xc6, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x21, 0x78, 0x01, 0x36, 0x8e, 0x42, 0xee, 
    0xd3, 0x00, 0x98, 0x00, 0x09, 0x07, 0xd3, 0xbf, 0x48, 0xff, 0x21, 0x3d, 0x31, 0x0e, 0x18, 
    0x29, 0x5c, 0x00, 0x25, 0x8d, 0x42, 0xd0, 0xd3, 0xbf, 0x48, 0x87, 0x30, 0xf8, 0xbd, 0x2c, 
    0x7a, 0x1a, 0x00, 0x70, 0xb5, 0x06, 0x1c, 0xb0, 0x68, 0xbc, 0x4d, 0x00, 0x28, 0x02, 0xd1, 
    0x28, 0x1c, 0xdf, 0x30, 0x70, 0xbd, 0x73, 0x4c, 0x04, 0x3c, 0x20, 0x7a, 0x02, 0x28, 0x08, 
    0xd0, 0xb7, 0x49, 0x08, 0x5c, 0x01, 0x21, 0x8e, 0x46, 0xb6, 0x49, 0xfe, 0x44, 0x08, 0x47, 
    0x00, 0x28, 0x02, 0xd0, 0x28, 0x1c, 0xcf, 0x30, 0x70, 0xbd, 0x00, 0x20, 0x20, 0x60, 0x70, 
    0x60, 0x28, 0x1c, 0xff, 0x30, 0x20, 0x30, 0x70, 0xbd, 0xc0, 0x46, 0xc9, 0x49, 0x05, 0x00, 
    0x10, 0xb5, 0x9c, 0x49, 0x11, 0x31, 0x06, 0x22, 0x00, 0x23, 0x0c, 0x78, 0xff, 0x2c, 0x02, 
    0xd1, 0x5b, 0x1c, 0x1b, 0x06, 0x1b, 0x0e, 0xdc, 0x31, 0x01, 0x3a, 0xf6, 0xd1, 0x43, 0x60, 
    0xa7, 0x48, 0x19, 0x30, 0x10, 0xbd, 0x01, 0x1c, 0xa7, 0x4b, 0x1a, 0x78, 0xa5, 0x48, 0x05, 
    0x2a, 0x04, 0xd1, 0xa5, 0x4a, 0x12, 0x68, 0x12, 0x78, 0x01, 0x2a, 0x02, 0xd0, 0x4b, 0x60, 
    0x5b, 0x30, 0xf7, 0x46, 0x7d, 0x30, 0xf7, 0x46, 0x10, 0xb5, 0x01, 0x1c, 0xa0, 0x48, 0x00, 
    0x68, 0xa1, 0x4c, 0x00, 0x28, 0x0b, 0xd0, 0x88, 0x69, 0x09, 0x7a, 0x01, 0x22, 0x96, 0x46, 
    0x9d, 0x4a, 0xfe, 0x44, 

    0x01, 0x05, 0xff, 0xff, 0x3a, 0x73, 0x08, 0x00, 0xfa, 0x10, 0x47, 0x00, 0x28, 0x02, 0xd0, 
    0x20, 0x1c, 0x21, 0x30, 0x10, 0xbd, 0x20, 0x1c, 0x33, 0x30, 0x10, 0xbd, 0x48, 0x53, 0x08, 
    0x00, 0xe2, 0x04, 0x00, 0x00, 0x71, 0x55, 0x00, 0x00, 0xf8, 0xb5, 0x81, 0x69, 0x00, 0x91, 
    0x92, 0x4c, 0x25, 0x1c, 0x0c, 0x3d, 0xe9, 0x68, 0x08, 0x22, 0x57, 0x18, 0x40, 0x69, 0x90, 
    0x4a, 0x00, 0x28, 0x02, 0xd0, 0x10, 0x1c, 0xd3, 0x30, 0xf8, 0xbd, 0x00, 0x26, 0x04, 0xe0, 
    0x70, 0x1c, 0x06, 0x06, 0x36, 0x0e, 0x06, 0x37, 0x21, 0x68, 0x48, 0x88, 0x86, 0x42, 0x14, 
    0xda, 0x38, 0x1c, 0x00, 0x99, 0x01, 0x22, 0x96, 0x46, 0x87, 0x4a, 0xfe, 0x44, 0x10, 0x47, 
    0x00, 0x28, 0xee, 0xd1, 0x0c, 0x34, 0xe8, 0x68, 0x41, 0x88, 0x01, 0x20, 0x88, 0x40, 0xe1, 
    0x6f, 0x81, 0x43, 0xe1, 0x67, 0xe9, 0x68, 0x48, 0x88, 0x01, 0x38, 0x48, 0x80, 0x7e, 0x48, 
    0xff, 0x30, 0x14, 0x30, 0xf8, 0xbd, 0xc0, 0x46, 0xc1, 0x0b, 0x04, 0x00, 0x98, 0x3a, 0x00, 
    0x00, 0xbb, 0x16, 0x04, 0x00, 0xc2, 0x4f, 0x08, 0x00, 0x24, 0x56, 0x08, 0x00, 0x6d, 0x0b, 
    0x04, 0x00, 0x4b, 0x70, 0x08, 0x00, 0xc9, 0x4c, 0x02, 0x00, 0x00, 0x59, 0x00, 0x01, 0x40, 
    0x31, 0xf7, 0x00, 0xdd, 0xd6, 0x02, 0x00, 0x70, 0xb5, 0x72, 0x48, 0x05, 0x78, 0x00, 0x24, 
    0x71, 0x48, 0x00, 0x88, 0x80, 0x09, 0x10, 0xd3, 0x01, 0x20, 0x06, 0x1c, 0x86, 0x46, 0x6f, 
    0x49, 0xfe, 0x44, 0x08, 0x47, 0x00, 0x28, 0x08, 0xd0, 0x3f, 0x22, 0x6d, 0x49, 0x08, 0x78, 
    0x02, 0x28, 0x03, 0xd1, 0x50, 0x5c, 0x00, 0x28, 0x00, 0xd0, 0x34, 0x1c, 0x6a, 0x48, 0xff, 
    0x2d, 0x01, 0xd0, 0x00, 0x2c, 0x01, 0xd0, 0x41, 0x30, 0x70, 0xbd, 0x0d, 0x30, 0x70, 0xbd, 
    0xd1, 0xcd, 0x02, 0x00, 

    0x01, 0x05, 0xff, 0xff, 0x34, 0x74, 0x08, 0x00, 0xfa, 0x01, 0x1c, 0x66, 0x48, 0x02, 0x78, 
    0x64, 0x48, 0x00, 0x2a, 0x01, 0xd0, 0xed, 0x30, 0xf7, 0x46, 0x41, 0x22, 0x4a, 0x60, 0x39, 
    0x30, 0xf7, 0x46, 0x00, 0x5a, 0x62, 0x02, 0x00, 0x6c, 0xdc, 0x02, 0x38, 0x58, 0xdb, 0x02, 
    0xcc, 0xb5, 0x62, 0x02, 0x99, 0x29, 0x03, 0x00, 0x57, 0x4a, 0x05, 0x00, 0x04, 0xf3, 0x1a, 
    0x00, 0x80, 0x7b, 0x08, 0x00, 0x76, 0xa0, 0x1b, 0x00, 0x6d, 0x97, 0x00, 0x00, 0x6c, 0x55, 
    0x08, 0x00, 0x4f, 0x61, 0x04, 0x00, 0x39, 0xc1, 0x02, 0x00, 0x7d, 0xc4, 0x02, 0x00, 0xf8, 
    0xb5, 0x06, 0x1c, 0x75, 0x69, 0xb7, 0x69, 0x31, 0x6a, 0x30, 0x7f, 0x00, 0x28, 0x2d, 0xd1, 
    0x01, 0x21, 0xa8, 0x8d, 0x18, 0x28, 0x27, 0xdc, 0x50, 0x48, 0x00, 0x78, 0x00, 0x90, 0x00, 
    0x24, 0x01, 0x22, 0xa2, 0x40, 0x00, 0x98, 0x10, 0x42, 0x1b, 0xd0, 0x49, 0x48, 0x20, 0x5c, 
    0x11, 0x21, 0x49, 0x01, 0x41, 0x43, 0x47, 0x48, 0x41, 0x18, 0xff, 0x20, 0x1e, 0x30, 0x40, 
    0x5c, 0x01, 0x28, 0x01, 0xd1, 0x02, 0x20, 0x00, 0xe0, 0x00, 0x20, 0xc9, 0x78, 0x08, 0x18, 
    0x44, 0x49, 0x08, 0x5c, 0xa9, 0x8d, 0x01, 0x22, 0x96, 0x46, 0x43, 0x4a, 0xfe, 0x44, 0x10, 
    0x47, 0x48, 0x1c, 0x01, 0x06, 0x09, 0x0e, 0x01, 0x34, 0x07, 0x2c, 0xdb, 0xdb, 0xa8, 0x8d, 
    0x01, 0xe0, 0x48, 0x7d, 0xa9, 0x8d, 0x48, 0x43, 0x39, 0x68, 0x40, 0x18, 0x80, 0x01, 0x80, 
    0x09, 0x38, 0x60, 0x70, 0x60, 0x36, 0x48, 0x5d, 0x30, 0xf8, 0xbd, 0x01, 0x1c, 0x4a, 0x68, 
    0x13, 0x06, 0x1b, 0x0e, 0x36, 0x48, 0x03, 0xd1, 0x22, 0x4b, 0x1b, 0x78, 0x03, 0x2b, 0x05, 
    0xd0, 0x00, 0x2a, 0x01, 0xd0, 0x1d, 0x30, 0xf7, 0x46, 0xff, 0x30, 0xf7, 0x46, 0x13, 0x4a, 
    0x30, 0x23, 0x9b, 0x5c, 

    0x01, 0x05, 0xff, 0xff, 0x2e, 0x75, 0x08, 0x00, 0xfa, 0x00, 0x2b, 0x07, 0xd1, 0x30, 0x4b, 
    0x92, 0x88, 0x9a, 0x42, 0x03, 0xd1, 0x2d, 0x4a, 0x12, 0x78, 0x00, 0x2a, 0x01, 0xd0, 0x00, 
    0x22, 0x00, 0xe0, 0x07, 0x22, 0x4a, 0x60, 0xff, 0x30, 0xa2, 0x30, 0xf7, 0x46, 0x5c, 0x27, 
    0x08, 0x00, 0x4b, 0x1e, 0x04, 0x00, 0x05, 0x5e, 0x02, 0x00, 0x40, 0x69, 0x78, 0x21, 0x09, 
    0x5a, 0x25, 0x48, 0xac, 0x29, 0x01, 0xda, 0x3b, 0x30, 0xf7, 0x46, 0x89, 0x30, 0xf7, 0x46, 
    0xc9, 0x98, 0x00, 0x00, 0xf0, 0xff, 0xff, 0x00, 0x48, 0x25, 0x08, 0x00, 0x6a, 0x0a, 0x00, 
    0x00, 0x47, 0x93, 0x02, 0x00, 0xb2, 0x2f, 0x08, 0x00, 0x49, 0xa0, 0x02, 0x00, 0x25, 0x6e, 
    0x03, 0x00, 0x3c, 0x91, 0x06, 0x00, 0x17, 0x62, 0x04, 0x00, 0xef, 0x8a, 0x04, 0x00, 0xd9, 
    0xae, 0x02, 0x00, 0x41, 0x10, 0x08, 0x00, 0xa8, 0x63, 0x08, 0x00, 0xec, 0x0e, 0x08, 0x00, 
    0x5d, 0x86, 0x01, 0x00, 0xdd, 0xf8, 0x03, 0x00, 0x79, 0x1c, 0x04, 0x00, 0xc2, 0x22, 0x08, 
    0x00, 0x7a, 0x7f, 0x1a, 0x00, 0x93, 0x68, 0x04, 0x00, 0xe4, 0x21, 0x08, 0x00, 0xe9, 0xcb, 
    0x01, 0x00, 0xdd, 0x84, 0x01, 0x00, 0xfc, 0x63, 0x08, 0x00, 0x00, 0x16, 0x08, 0x00, 0x00, 
    0x00, 0x08, 0x00, 0x09, 0x82, 0x01, 0x00, 0xb5, 0x63, 0x08, 0x00, 0xac, 0x63, 0x08, 0x00, 
    0x6d, 0x94, 0x05, 0x00, 0xbd, 0x7b, 0x03, 0x00, 0xf5, 0x50, 0x08, 0x00, 0xff, 0xff, 0x00, 
    0x00, 0xe5, 0x85, 0x00, 0x00, 0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0x3e, 0xfa, 0xff, 0xbd, 
    0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0x1d, 0xfa, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xff, 
    0xf7, 0xb2, 0xf9, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0x0d, 0xfb, 0xff, 0xbd, 
    0xff, 0xb5, 0x68, 0x46, 

    0x01, 0x05, 0xff, 0x65, 0x28, 0x76, 0x08, 0x00, 0x60, 0xff, 0xf7, 0x9e, 0xfa, 0xff, 0xbd, 
    0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0x51, 0xfa, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xfe, 
    0xf7, 0xfa, 0xff, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0x04, 0xf8, 0xff, 0xbd, 
    0xff, 0xb5, 0x68, 0x46, 0xfe, 0xf7, 0x74, 0xff, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xfe, 
    0xf7, 0xaf, 0xff, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0x68, 0xf9, 0xff, 0xbd, 
    0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0xaf, 0xf9, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xff, 
    0xf7, 0x17, 0xf8, 0xff, 0xbd, 0xff, 0xb5, 0x68, 0x46, 0xff, 0xf7, 0xa5, 0xf8, 0xff, 0xbd, 
    

    0x01, 0x05, 0xff, 0x8d, 0x78, 0x7b, 0x08, 0x00, 0x88, 0x00, 0xb5, 0xf8, 0xf0, 0x31, 0xfd, 
    0x00, 0xbd, 0x95, 0x71, 0x08, 0x00, 0x15, 0x71, 0x08, 0x00, 0x39, 0x71, 0x08, 0x00, 0xc1, 
    0x71, 0x08, 0x00, 0xc1, 0x71, 0x08, 0x00, 0xf5, 0x06, 0x18, 0x00, 0xf7, 0x70, 0x08, 0x00, 
    0x0d, 0x72, 0x08, 0x00, 0x95, 0x72, 0x08, 0x00, 0xdd, 0x72, 0x08, 0x00, 0x01, 0x73, 0x08, 
    0x00, 0x21, 0x73, 0x08, 0x00, 0xed, 0x73, 0x08, 0x00, 0xbd, 0x6d, 0x08, 0x00, 0x59, 0x07, 
    0x18, 0x00, 0x35, 0x74, 0x08, 0x00, 0x85, 0x74, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x59, 
    0x73, 0x08, 0x00, 0x09, 0x75, 0x08, 0x00, 0x63, 0x70, 0x08, 0x00, 0x5d, 0x75, 0x08, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

    0x01, 0x05, 0xff, 0x85, 0x04, 0xf3, 0x1a, 0x00, 0x80, 0x36, 0x5e, 0x02, 0x00, 0x38, 0xc2, 
    0x02, 0x00, 0x00, 0xc5, 0x02, 0x00, 0x9c, 0x9c, 0x00, 0x00, 0x08, 0x9c, 0x00, 0x00, 0x02, 
    0x69, 0x00, 0x00, 0x84, 0x97, 0x00, 0x00, 0x6a, 0xa0, 0x02, 0x00, 0xf0, 0x6e, 0x03, 0x00, 
    0xf0, 0x8a, 0x04, 0x00, 0x32, 0xaf, 0x02, 0x00, 0xf4, 0xf8, 0x03, 0x00, 0xf4, 0xcb, 0x01, 
    0x00, 0xa8, 0x55, 0x00, 0x00, 0x00, 0x16, 0x04, 0x00, 0x14, 0x85, 0x01, 0x00, 0x54, 0x82, 
    0x01, 0x00, 0xff, 0xff, 0xff, 0xff, 0xac, 0xf9, 0x03, 0x00, 0xd6, 0x7b, 0x03, 0x00, 0x2c, 
    0xd7, 0x02, 0x00, 0x1c, 0x86, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 

    0x01, 0x05, 0xff, 0xff, 0x00, 0x00, 0x18, 0x00, 0xfa, 0xf0, 0xb5, 0x8c, 0xb0, 0xad, 0x48, 
    0x06, 0xc8, 0x6f, 0x46, 0x68, 0x46, 0x06, 0xc0, 0xac, 0x48, 0x06, 0xc8, 0x02, 0xa8, 0x06, 
    0xc0, 0xfb, 0x48, 0x06, 0xc8, 0x04, 0xa8, 0x06, 0xc0, 0xfa, 0x48, 0x06, 0xc8, 0x06, 0xa8, 
    0x06, 0xc0, 0xf9, 0x48, 0x06, 0xc8, 0x08, 0xa8, 0x06, 0xc0, 0xf8, 0x48, 0x06, 0xc8, 0x0a, 
    0xa8, 0x06, 0xc0, 0x0c, 0x26, 0xf1, 0x48, 0x48, 0x30, 0x31, 0x1c, 0x01, 0x24, 0xa6, 0x46, 
    0xf4, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x9e, 0x4d, 0xa8, 0x78, 0x00, 0x28, 0x19, 0xd1, 0x03, 
    0x20, 0x01, 0x1c, 0xf0, 0x48, 0xa6, 0x46, 0xee, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xef, 0x48, 
    0x03, 0x21, 0xa6, 0x46, 0xeb, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xed, 0x48, 0x00, 0x21, 0x32, 
    0x1c, 0xa6, 0x46, 0xec, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xe8, 0x48, 0x02, 0x21, 0xa6, 0x46, 
    0xea, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xde, 0x48, 0x04, 0x21, 0xa6, 0x46, 0xe7, 0x4a, 0xfe, 
    0x44, 0x10, 0x47, 0xea, 0x4e, 0x30, 0x1c, 0x4c, 0x38, 0x02, 0x21, 0xa6, 0x46, 0xde, 0x4a, 
    0xfe, 0x44, 0x10, 0x47, 0xe2, 0x48, 0x0a, 0x99, 0x01, 0x60, 0xb9, 0x8d, 0x81, 0x80, 0x27, 
    0x1c, 0x21, 0x1c, 0xe0, 0x48, 0x98, 0x30, 0x8e, 0x46, 0xd7, 0x4a, 0xfe, 0x44, 0x10, 0x47, 
    0xdd, 0x48, 0x00, 0x99, 0x01, 0x60, 0x01, 0x99, 0x41, 0x60, 0x02, 0x99, 0x01, 0x62, 0x03, 
    0x99, 0x41, 0x62, 0x04, 0x99, 0x01, 0x63, 0x05, 0x99, 0x41, 0x63, 0x06, 0x99, 0x81, 0x64, 
    0x07, 0x99, 0xc1, 0x64, 0x08, 0x99, 0x01, 0x66, 0x09, 0x99, 0x41, 0x66, 0x9c, 0x30, 0x21, 
    0x1c, 0x8e, 0x46, 0xca, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xd0, 0x48, 0x00, 0x78, 0x01, 0x28, 
    0x00, 0xd1, 0xa3, 0xe0, 

    0x01, 0x05, 0xff, 0xff, 0xfa, 0x00, 0x18, 0x00, 0xfa, 0x00, 0x28, 0x00, 0xd1, 0xda, 0xe0, 
    0x02, 0x28, 0x00, 0xd0, 0xd7, 0xe0, 0x30, 0x1c, 0x05, 0x21, 0xbe, 0x46, 0xf9, 0x4a, 0xfe, 
    0x44, 0x10, 0x47, 0x01, 0x1c, 0xc8, 0x48, 0x00, 0x22, 0xbe, 0x46, 0xc2, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0xa8, 0x78, 0x00, 0x28, 0x16, 0xd1, 0x13, 0x20, 0xc5, 0x49, 0x08, 0x80, 0x03, 
    0x25, 0x29, 0x1c, 0x20, 0x1c, 0xa6, 0x46, 0xc3, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xb8, 0x48, 
    0x29, 0x1c, 0xbe, 0x46, 0xb4, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xb6, 0x48, 0x00, 0x21, 0x0c, 
    0x22, 0xbe, 0x46, 0xb5, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xaa, 0x4e, 0x06, 0x3e, 0x30, 0x1c, 
    0x02, 0x21, 0x00, 0x22, 0xbe, 0x46, 0xb9, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xa6, 0x4d, 0x04, 
    0x3d, 0xb8, 0x4f, 0x38, 0x1c, 0xc8, 0x38, 0x28, 0x60, 0x30, 0x1c, 0x03, 0x21, 0x00, 0x22, 
    0xa6, 0x46, 0xb3, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x2f, 0x60, 0x30, 0x1c, 0x04, 0x21, 0x00, 
    0x22, 0xa6, 0x46, 0xaf, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xaf, 0x4f, 0x38, 0x1c, 0xd1, 0x38, 
    0x28, 0x60, 0x30, 0x1c, 0x05, 0x21, 0x00, 0x22, 0xa6, 0x46, 0xa9, 0x4b, 0xfe, 0x44, 0x18, 
    0x47, 0x2f, 0x60, 0x30, 0x1c, 0x06, 0x21, 0x00, 0x22, 0xa6, 0x46, 0xa5, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0x38, 0x1c, 0x32, 0x30, 0x28, 0x60, 0x30, 0x1c, 0x07, 0x21, 0x00, 0x22, 0xa6, 
    0x46, 0xa0, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x38, 0x1c, 0x62, 0x30, 0x28, 0x60, 0x30, 0x1c, 
    0x08, 0x21, 0x00, 0x22, 0xa6, 0x46, 0x9b, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xc2, 0x37, 0x2f, 
    0x60, 0x30, 0x1c, 0x09, 0x21, 0x00, 0x22, 0xa6, 0x46, 0x97, 0x4b, 0xfe, 0x44, 0x18, 0x47, 
    0xea, 0x48, 0x28, 0x60, 

    0x01, 0x05, 0xff, 0xff, 0xf4, 0x01, 0x18, 0x00, 0xfa, 0x30, 0x1c, 0x0a, 0x21, 0x00, 0x22, 
    0xa6, 0x46, 0x92, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xe7, 0x48, 0x28, 0x60, 0x30, 0x1c, 0x0b, 
    0x21, 0x00, 0x22, 0xa6, 0x46, 0x8e, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0xe3, 0x48, 0x28, 0x60, 
    0xe3, 0x48, 0x00, 0x88, 0x80, 0x0b, 0x4a, 0xd3, 0x00, 0x22, 0x10, 0x1c, 0xc3, 0x00, 0x82, 
    0x49, 0x06, 0x39, 0xc9, 0x18, 0x0c, 0x88, 0x24, 0x06, 0x24, 0x0e, 0x0c, 0x80, 0x7e, 0x49, 
    0x04, 0x39, 0xca, 0x52, 0x01, 0x30, 0x14, 0x28, 0xf1, 0xdb, 0x39, 0xe0, 0xbe, 0x46, 0xd9, 
    0x48, 0xfe, 0x44, 0x00, 0x47, 0xbe, 0x46, 0xda, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xc0, 0x06, 
    0xc0, 0x0e, 0x81, 0x02, 0xd6, 0x48, 0x00, 0x78, 0x40, 0x06, 0x40, 0x0e, 0x08, 0x43, 0x03, 
    0x21, 0x09, 0x02, 0x01, 0x43, 0xd1, 0x48, 0x00, 0x68, 0x81, 0x86, 0xd3, 0x48, 0x04, 0x70, 
    0xd4, 0x48, 0xd2, 0x49, 0x08, 0x80, 0xd3, 0x4d, 0x28, 0x1c, 0x08, 0x38, 0x02, 0x21, 0xbe, 
    0x46, 0x64, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x28, 0x1c, 0x07, 0x21, 0x0c, 0x22, 0xbe, 0x46, 
    0xce, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x00, 0x26, 0x32, 0x1c, 0xce, 0x4d, 0x28, 0x1c, 0x04, 
    0x38, 0x37, 0x21, 0xbe, 0x46, 0xca, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x28, 0x1c, 0x31, 0x1c, 
    0xbe, 0x46, 0x58, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x0c, 0xb0, 0xf0, 0xbd, 0xc0, 0x46, 0xa4, 
    0x62, 0x08, 0x00, 0xac, 0x62, 0x08, 0x00, 0x60, 0x56, 0x08, 0x00, 0xf0, 0xb5, 0x5a, 0x48, 
    0x00, 0x78, 0x01, 0x28, 0x44, 0xd0, 0x00, 0x28, 0x34, 0xd0, 0x02, 0x28, 0x00, 0xd0, 0x90, 
    0xe0, 0xbe, 0x49, 0x48, 0x20, 0x40, 0x18, 0x03, 0x88, 0x01, 0x22, 0x1a, 0x43, 0x02, 0x80, 
    0xaf, 0x4a, 0x70, 0x3a, 

    0x01, 0x05, 0xff, 0xff, 0xee, 0x02, 0x18, 0x00, 0xfa, 0x13, 0x88, 0x9b, 0x10, 0x9b, 0x00, 
    0x13, 0x80, 0x7c, 0x23, 0x82, 0x8e, 0x9a, 0x43, 0x32, 0x23, 0x13, 0x43, 0x83, 0x86, 0xb6, 
    0x48, 0x7a, 0x30, 0x02, 0x88, 0x52, 0x09, 0x53, 0x01, 0x08, 0x22, 0x1a, 0x43, 0x02, 0x80, 
    0x08, 0x88, 0x40, 0x10, 0x40, 0x00, 0x08, 0x80, 0xf3, 0x4b, 0xff, 0x24, 0x18, 0x88, 0x20, 
    0x40, 0x03, 0x22, 0x12, 0x02, 0x02, 0x43, 0x1a, 0x80, 0x18, 0x89, 0x20, 0x40, 0xff, 0x22, 
    0x01, 0x32, 0x02, 0x43, 0x1a, 0x81, 0x02, 0x22, 0x08, 0x88, 0x90, 0x43, 0x08, 0x80, 0xf0, 
    0xbd, 0x07, 0x21, 0x09, 0x02, 0xea, 0x48, 0xc2, 0x38, 0x0a, 0x1c, 0x01, 0x24, 0xa6, 0x46, 
    0xe7, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x99, 0x48, 0x01, 0x38, 0x04, 0x70, 0xf0, 0xbd, 0x00, 
    0x26, 0xe4, 0x48, 0x31, 0x1c, 0x02, 0x22, 0x01, 0x24, 0xa6, 0x46, 0xe0, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0x96, 0x4d, 0x28, 0x1c, 0x08, 0x38, 0x02, 0x21, 0xa6, 0x46, 0x26, 0x4a, 0xfe, 
    0x44, 0x10, 0x47, 0x02, 0x35, 0x28, 0x1c, 0x07, 0x27, 0x31, 0x1c, 0x0a, 0x1c, 0x39, 0x1c, 
    0xa6, 0x46, 0x8f, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x28, 0x1c, 0x39, 0x1c, 0x03, 0x22, 0xa6, 
    0x46, 0x8c, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x8c, 0x4d, 0x28, 0x1c, 0x04, 0x38, 0x08, 0x21, 
    0x3a, 0x1c, 0xa6, 0x46, 0xec, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x28, 0x1c, 0x02, 0x38, 0x04, 
    0x21, 0xa6, 0x46, 0xea, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x28, 0x1c, 0x31, 0x1c, 0xa6, 0x46, 
    0x13, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x0c, 0x49, 0x58, 0x31, 0x0e, 0x80, 0x0c, 0x25, 0x29, 
    0x1c, 0x81, 0x48, 0xa6, 0x46, 0x13, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xc3, 0x48, 0xa6, 0x38, 
    0x31, 0x1c, 0x0a, 0x1c, 

    0x01, 0x05, 0xff, 0xff, 0xe8, 0x03, 0x18, 0x00, 0xfa, 0xa6, 0x46, 0x79, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0xbf, 0x48, 0x64, 0x38, 0x29, 0x1c, 0xa6, 0x46, 0x06, 0x4a, 0xfe, 0x44, 0x10, 
    0x47, 0xf0, 0xbd, 0x10, 0x60, 0x1a, 0x00, 0xb4, 0x62, 0x08, 0x00, 0xbc, 0x62, 0x08, 0x00, 
    0xc4, 0x62, 0x08, 0x00, 0xcc, 0x62, 0x08, 0x00, 0x61, 0x48, 0x05, 0x00, 0x08, 0xf0, 0x1a, 
    0x00, 0x1e, 0xf6, 0x1a, 0x00, 0x14, 0xf6, 0x1a, 0x00, 0xd3, 0x48, 0x05, 0x00, 0x79, 0x48, 
    0x05, 0x00, 0x98, 0x0b, 0x1a, 0x00, 0x08, 0x09, 0x1a, 0x00, 0xe8, 0x57, 0x08, 0x00, 0x6a, 
    0x31, 0x19, 0x00, 0xc4, 0x61, 0x1a, 0x00, 0x9e, 0x13, 0x08, 0x00, 0x21, 0x99, 0x05, 0x00, 
    0xff, 0x48, 0x05, 0x00, 0xdc, 0x09, 0x04, 0x00, 0x25, 0x0d, 0x04, 0x00, 0xf0, 0xb5, 0xba, 
    0xb0, 0xa5, 0x4d, 0x2e, 0x1c, 0x56, 0x36, 0x30, 0x1c, 0x08, 0x21, 0x01, 0x24, 0xa6, 0x46, 
    0xc0, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x06, 0x00, 0x0e, 0x37, 0x90, 0x30, 0x1c, 0x00, 
    0x21, 0xa6, 0x46, 0xbc, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x06, 0x04, 0x28, 0x1c, 0x54, 0x30, 
    0x00, 0x88, 0x06, 0x43, 0x2f, 0x1c, 0x52, 0x37, 0x38, 0x1c, 0x08, 0x21, 0xa6, 0x46, 0xb7, 
    0x4a, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x06, 0x00, 0x0e, 0x38, 0x90, 0x50, 0x35, 0x28, 0x1c, 
    0x00, 0x21, 0xa6, 0x46, 0xb3, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x39, 0x90, 0x28, 0x1c, 0x0c, 
    0x21, 0xa6, 0x46, 0x0f, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x05, 0x1c, 0x38, 0x1c, 0x00, 0x21, 
    0xa6, 0x46, 0xaa, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x00, 0x01, 0x28, 0x43, 0x05, 0x04, 0x2d, 
    0x0c, 0x02, 0xa8, 0xa9, 0x49, 0xd4, 0x22, 0xa6, 0x46, 0xa8, 0x4b, 0xfe, 0x44, 0x18, 0x47, 
    0x37, 0x98, 0x08, 0x28, 

    0x01, 0x05, 0xff, 0xff, 0xe2, 0x04, 0x18, 0x00, 0xfa, 0x58, 0xd1, 0xa6, 0x48, 0xa7, 0x49, 
    0x42, 0x79, 0x0b, 0x78, 0x93, 0x42, 0x52, 0xd1, 0x02, 0xe0, 0xc0, 0x46, 0x57, 0x4a, 0x05, 
    0x00, 0x02, 0x79, 0x4b, 0x78, 0x93, 0x42, 0x4a, 0xd1, 0xc2, 0x78, 0x8b, 0x78, 0x93, 0x42, 
    0x46, 0xd1, 0xff, 0xe7, 0x82, 0x78, 0xcb, 0x78, 0x93, 0x42, 0x41, 0xd1, 0x42, 0x78, 0x0b, 
    0x79, 0x93, 0x42, 0x3d, 0xd1, 0x00, 0x78, 0x49, 0x79, 0x81, 0x42, 0x39, 0xd1, 0x00, 0x21, 
    0x08, 0x1c, 0x0b, 0xe0, 0x35, 0x28, 0x34, 0xda, 0x82, 0x00, 0x02, 0xab, 0x9a, 0x58, 0x96, 
    0x42, 0x03, 0xd0, 0x40, 0x1c, 0x00, 0x06, 0x00, 0x0e, 0x00, 0xe0, 0x21, 0x1c, 0x00, 0x29, 
    0xf1, 0xd0, 0x78, 0x22, 0x69, 0x46, 0x0a, 0x70, 0xde, 0x22, 0x4a, 0x70, 0xe4, 0x22, 0x8a, 
    0x70, 0x42, 0x01, 0x38, 0x98, 0x02, 0x43, 0x90, 0x01, 0x28, 0x43, 0x80, 0x01, 0x39, 0x9a, 
    0x10, 0x43, 0x02, 0x0c, 0xca, 0x70, 0x02, 0x0a, 0x0a, 0x71, 0x48, 0x71, 0x86, 0x48, 0x05, 
    0x1c, 0xa6, 0x46, 0x86, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x1f, 0x20, 0xa6, 0x46, 0x84, 0x49, 
    0xfe, 0x44, 0x08, 0x47, 0x84, 0x48, 0x00, 0x78, 0x02, 0x28, 0x05, 0xd1, 0x28, 0x1c, 0x00, 
    0x21, 0xa6, 0x46, 0x81, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x3a, 0xb0, 0xf0, 0xbd, 0xc0, 0x46, 
    0x2f, 0x0e, 0x04, 0x00, 0x6a, 0x12, 0x40, 0x00, 0x85, 0x12, 0x00, 0x00, 0x5c, 0x7b, 0x1a, 
    0x00, 0x55, 0x04, 0x18, 0x00, 0xe8, 0x21, 0x08, 0x00, 0x0f, 0x51, 0x08, 0x00, 0x4f, 0x76, 
    0x04, 0x00, 0x09, 0x51, 0x08, 0x00, 0xb0, 0x63, 0x08, 0x00, 0xff, 0xff, 0x00, 0x00, 0x0a, 
    0x30, 0x1a, 0x00, 0xa7, 0x48, 0x05, 0x00, 0x15, 0x49, 0x05, 0x00, 0x08, 0x0f, 0x1a, 0x00, 
    0x24, 0x79, 0x1a, 0x00, 

    0x01, 0x05, 0xff, 0xff, 0xdc, 0x05, 0x18, 0x00, 0xfa, 0xda, 0x7c, 0x1a, 0x00, 0xf0, 0xb5, 
    0x6e, 0x4e, 0x06, 0x25, 0x35, 0x70, 0x0f, 0x23, 0x73, 0x70, 0x3d, 0x20, 0xb0, 0x70, 0x29, 
    0x20, 0xf0, 0x70, 0x03, 0x20, 0x2a, 0x1c, 0x7d, 0x49, 0xe4, 0x31, 0x01, 0x24, 0xa6, 0x46, 
    0x67, 0x4f, 0xfe, 0x44, 0x38, 0x47, 0xb2, 0x78, 0xf3, 0x78, 0x03, 0x20, 0x78, 0x49, 0xe5, 
    0x31, 0xa6, 0x46, 0x63, 0x4e, 0xfe, 0x44, 0x30, 0x47, 0x03, 0x20, 0x75, 0x49, 0xe6, 0x31, 
    0xa6, 0x46, 0x60, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0xa6, 0x46, 0x5f, 0x48, 0xfe, 0x44, 0x00, 
    0x47, 0x5f, 0x4a, 0x00, 0x21, 0x08, 0x1c, 0x13, 0x68, 0x00, 0x2b, 0x04, 0xd0, 0x03, 0x07, 
    0x1e, 0x0f, 0x23, 0x1c, 0xb3, 0x40, 0x19, 0x43, 0x03, 0x07, 0x1b, 0x0f, 0x0f, 0x2b, 0x05, 
    0xd1, 0xc6, 0x08, 0x2b, 0x1c, 0x33, 0x40, 0x57, 0x4e, 0xf1, 0x52, 0x00, 0x21, 0x04, 0x32, 
    0x01, 0x30, 0x20, 0x28, 0xe9, 0xd3, 0x00, 0x27, 0x54, 0x48, 0x07, 0x70, 0x19, 0x20, 0x40, 
    0x01, 0x53, 0x49, 0x08, 0x80, 0xff, 0x20, 0x52, 0x49, 0x08, 0x70, 0x52, 0x49, 0x08, 0x70, 
    0x52, 0x48, 0x07, 0x70, 0x53, 0x48, 0x52, 0x49, 0x08, 0x60, 0x53, 0x48, 0x24, 0x21, 0x01, 
    0x70, 0x18, 0x21, 0x41, 0x70, 0x20, 0x21, 0x81, 0x70, 0x10, 0x21, 0xc1, 0x70, 0x57, 0x48, 
    0x4f, 0x49, 0x08, 0x80, 0xa6, 0x46, 0x4e, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x4e, 0x4e, 0x4e, 
    0x4d, 0xa6, 0x46, 0x4e, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x31, 0x88, 0x01, 0x40, 0x48, 0x08, 
    0x04, 0xd0, 0x00, 0x20, 0xc0, 0x43, 0x45, 0x19, 0x85, 0x42, 0xf2, 0xd1, 0xa6, 0x46, 0x48, 
    0x48, 0xfe, 0x44, 0x00, 0x47, 0x31, 0x88, 0x01, 0x40, 0x48, 0x08, 0x04, 0xd0, 0x5c, 0x20, 
    0xa6, 0x46, 0x44, 0x49, 

    0x01, 0x05, 0xff, 0xff, 0xd6, 0x06, 0x18, 0x00, 0xfa, 0xfe, 0x44, 0x08, 0x47, 0xa6, 0x46, 
    0x43, 0x48, 0xfe, 0x44, 0x00, 0x47, 0x37, 0x80, 0xf0, 0xbd, 0xc0, 0x46, 0x2c, 0x7a, 0x1a, 
    0x00, 0xdb, 0x4a, 0x05, 0x00, 0xc2, 0x74, 0x1a, 0x00, 0x10, 0xb5, 0x43, 0x69, 0x31, 0x49, 
    0x09, 0x78, 0x3e, 0x4a, 0x12, 0x78, 0x01, 0x2a, 0x04, 0xd1, 0x1c, 0x78, 0x00, 0x2c, 0x01, 
    0xd1, 0x2c, 0x49, 0x09, 0x78, 0x3e, 0x4c, 0x24, 0x78, 0x00, 0x2c, 0x1b, 0xd0, 0xff, 0x29, 
    0x19, 0xd0, 0x01, 0x2a, 0x08, 0xd0, 0x37, 0x4a, 0x12, 0x78, 0x01, 0x2a, 0x13, 0xd0, 0x1a, 
    0x78, 0x01, 0x2a, 0x01, 0xd0, 0x02, 0x2a, 0x0e, 0xd1, 0x10, 0x22, 0xd4, 0x56, 0x8c, 0x42, 
    0x0a, 0xdd, 0x61, 0x1a, 0x09, 0x06, 0x09, 0x0e, 0x5b, 0x1c, 0x00, 0x24, 0x1c, 0x57, 0x64, 
    0x1a, 0x1c, 0x70, 0x01, 0x33, 0x01, 0x3a, 0xf8, 0xd1, 0x2c, 0x49, 0x81, 0x60, 0x2c, 0x48, 
    0x15, 0x30, 0x10, 0xbd, 0x2c, 0x48, 0x15, 0x30, 0xf7, 0x46, 0xc0, 0x46, 0x2b, 0x49, 0x05, 
    0x00, 0x41, 0x49, 0x05, 0x00, 0x61, 0x4a, 0x05, 0x00, 0x7f, 0x4a, 0x05, 0x00, 0x6b, 0x4a, 
    0x05, 0x00, 0xa7, 0x4a, 0x05, 0x00, 0xd4, 0x62, 0x08, 0x00, 0x21, 0xa7, 0x05, 0x00, 0x22, 
    0x17, 0x08, 0x00, 0x12, 0x56, 0x08, 0x00, 0x79, 0x10, 0x08, 0x00, 0x87, 0x1c, 0x04, 0x00, 
    0x9d, 0x31, 0x05, 0x00, 0x41, 0x10, 0x08, 0x00, 0xc3, 0x7a, 0x03, 0x00, 0x0c, 0x51, 0x08, 
    0x00, 0x0b, 0xd4, 0x04, 0x00, 0xf5, 0xd3, 0x04, 0x00, 0x8d, 0x0a, 0x18, 0x00, 0x80, 0x7b, 
    0x08, 0x00, 0x84, 0xf3, 0x1a, 0x00, 0xb5, 0x63, 0x08, 0x00, 0xcc, 0x24, 0x08, 0x00, 0xf4, 
    0x63, 0x08, 0x00, 0xf5, 0x63, 0x08, 0x00, 0xfc, 0x63, 0x08, 0x00, 0xa8, 0x63, 0x08, 0x00, 
    0x36, 0xa0, 0x1b, 0x00, 

    0x01, 0x05, 0xff, 0xff, 0xd0, 0x07, 0x18, 0x00, 0xfa, 0xac, 0x63, 0x08, 0x00, 0x4c, 0x25, 
    0x08, 0x00, 0x01, 0x00, 0x18, 0x00, 0x00, 0x7c, 0x1a, 0x00, 0xf0, 0xff, 0xff, 0x00, 0x07, 
    0xff, 0x03, 0x00, 0xd7, 0xd3, 0x04, 0x00, 0xc9, 0x02, 0x18, 0x00, 0xe1, 0x04, 0x00, 0x00, 
    0xff, 0xff, 0x00, 0x00, 0xfa, 0x63, 0x08, 0x00, 0xf7, 0x63, 0x08, 0x00, 0x10, 0x30, 0x19, 
    0x00, 0xef, 0x68, 0x00, 0x00, 0xe8, 0x57, 0x08, 0x00, 0xff, 0x15, 0x04, 0x00, 0xf0, 0xb5, 
    0xc3, 0x49, 0x0c, 0x78, 0x0e, 0x2c, 0x2c, 0xda, 0xc2, 0x4e, 0x3f, 0x20, 0x85, 0x19, 0x60, 
    0x1c, 0x00, 0x06, 0x00, 0x0e, 0x28, 0x70, 0xbf, 0x4b, 0xa2, 0x00, 0xbf, 0x4f, 0x9f, 0x50, 
    0x0e, 0x28, 0x18, 0xda, 0xa2, 0x1c, 0x12, 0x06, 0x12, 0x0e, 0x6a, 0x70, 0x80, 0x00, 0xbc, 
    0x4d, 0x1d, 0x50, 0x0e, 0x2a, 0x08, 0xda, 0xe0, 0x1c, 0x70, 0x72, 0x90, 0x00, 0xb9, 0x4a, 
    0x1a, 0x50, 0x08, 0x78, 0x03, 0x30, 0x08, 0x70, 0xf0, 0xbd, 0x0a, 0x70, 0x01, 0x20, 0x86, 
    0x46, 0xb6, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xfe, 0xe7, 0x08, 0x70, 0x01, 0x20, 0x86, 0x46, 
    0xb2, 0x48, 0xfe, 0x44, 0x00, 0x47, 0xfe, 0xe7, 0x01, 0x20, 0x86, 0x46, 0xaf, 0x48, 0xfe, 
    0x44, 0x00, 0x47, 0xfe, 0xe7, 0xf8, 0xb5, 0x07, 0x1c, 0xfb, 0x7a, 0xad, 0x48, 0x03, 0x70, 
    0x3a, 0x7b, 0xac, 0x48, 0x02, 0x70, 0xac, 0x49, 0x7c, 0x7b, 0x0c, 0x70, 0xac, 0x48, 0xbd, 
    0x7b, 0x05, 0x70, 0xb3, 0x4e, 0x00, 0x2b, 0x00, 0xd0, 0xbe, 0xe0, 0xad, 0x4a, 0x15, 0x1c, 
    0x8c, 0x3d, 0xb6, 0x4e, 0xb6, 0x0b, 0x01, 0x24, 0xa6, 0x46, 0xa6, 0x48, 0xfe, 0x44, 0x00, 
    0x47, 0x29, 0x88, 0x01, 0x40, 0x48, 0x08, 0x05, 0xd0, 0x30, 0x1c, 0x41, 0x1e, 0x0e, 0x04, 
    0x36, 0x0c, 0x00, 0x28, 

    0x01, 0x05, 0xff, 0xff, 0xca, 0x08, 0x18, 0x00, 0xfa, 0xf0, 0xd1, 0xa6, 0x46, 0x9f, 0x48, 
    0xfe, 0x44, 0x00, 0x47, 0x29, 0x88, 0x01, 0x40, 0x48, 0x08, 0x04, 0xd0, 0x58, 0x20, 0xa6, 
    0x46, 0x9b, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x98, 0x48, 0x00, 0x78, 0x9a, 0x4e, 0x01, 0x28, 
    0x34, 0xd0, 0x00, 0x20, 0x01, 0x1c, 0x0c, 0x20, 0x02, 0x1c, 0x30, 0x1c, 0xa6, 0x46, 0x96, 
    0x4b, 0xfe, 0x44, 0x18, 0x47, 0x96, 0x48, 0x00, 0x21, 0x08, 0x22, 0xa6, 0x46, 0x95, 0x4b, 
    0xfe, 0x44, 0x18, 0x47, 0x92, 0x4e, 0x24, 0x36, 0x30, 0x1c, 0x21, 0x1c, 0x0c, 0x22, 0xa6, 
    0x46, 0x9a, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x07, 0x20, 0x01, 0x1c, 0x20, 0x1c, 0xa6, 0x46, 
    0x8e, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x14, 0x20, 0xa6, 0x46, 0x8c, 0x49, 0xfe, 0x44, 0x08, 
    0x47, 0x07, 0x20, 0xa6, 0x46, 0x8c, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x89, 0x49, 0x08, 0x70, 
    0x30, 0x1c, 0x00, 0x21, 0x0c, 0x22, 0xa6, 0x46, 0x8d, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x85, 
    0x4e, 0x5b, 0xe0, 0x30, 0x1c, 0x00, 0x21, 0x08, 0x22, 0xa6, 0x46, 0x7d, 0x4b, 0xfe, 0x44, 
    0x18, 0x47, 0x30, 0x1c, 0x00, 0x21, 0x0c, 0x22, 0xa6, 0x46, 0x79, 0x4b, 0xfe, 0x44, 0x18, 
    0x47, 0x79, 0x48, 0x00, 0x21, 0x0a, 0x1c, 0xa6, 0x46, 0x78, 0x4b, 0xfe, 0x44, 0x18, 0x47, 
    0x75, 0x48, 0x00, 0x21, 0x08, 0x22, 0xa6, 0x46, 0x74, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x03, 
    0x20, 0x02, 0x1c, 0x71, 0x48, 0x02, 0x21, 0xa6, 0x46, 0x7a, 0x4b, 0xfe, 0x44, 0x18, 0x47, 
    0x0b, 0x20, 0x02, 0x1c, 0x6d, 0x48, 0x21, 0x1c, 0x8e, 0x46, 0x76, 0x4b, 0xfe, 0x44, 0x18, 
    0x47, 0x20, 0x1c, 0x06, 0x21, 0xa6, 0x46, 0x6a, 0x4a, 0xfe, 0x44, 0x10, 0x47, 0x07, 0x20, 
    0x01, 0x1c, 0x20, 0x1c, 

    0x01, 0x05, 0xff, 0xff, 0xc4, 0x09, 0x18, 0x00, 0xfa, 0xa6, 0x46, 0x67, 0x4a, 0xfe, 0x44, 
    0x10, 0x47, 0x14, 0x20, 0xa6, 0x46, 0x65, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x65, 0x4e, 0x07, 
    0x20, 0xa6, 0x46, 0x64, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x00, 0x90, 0x06, 0x20, 0xa6, 0x46, 
    0x61, 0x49, 0xfe, 0x44, 0x08, 0x47, 0x41, 0x00, 0x00, 0x98, 0x01, 0x43, 0x31, 0x70, 0x59, 
    0x48, 0x00, 0x21, 0x03, 0x22, 0xa6, 0x46, 0x62, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x55, 0x48, 
    0x00, 0x21, 0x0b, 0x22, 0xa6, 0x46, 0x5e, 0x4b, 0xfe, 0x44, 0x18, 0x47, 0x00, 0x20, 0x28, 
    0x80, 0x4b, 0x48, 0x04, 0x78, 0x4b, 0x48, 0x05, 0x78, 0x32, 0x78, 0x01, 0xe0, 0x30, 0x1c, 
    0x02, 0x70, 0xfb, 0x7b, 0x01, 0x2d, 0x25, 0xd1, 0x00, 0x2c, 0x0d, 0xd1, 0x10, 0x1c, 0x09, 
    0xd0, 0x01, 0x38, 0x05, 0xd0, 0x01, 0x38, 0x01, 0xd0, 0x06, 0x20, 0x16, 0xe0, 0x04, 0x20, 
    0x14, 0xe0, 0x02, 0x20, 0x12, 0xe0, 0x00, 0x20, 0x10, 0xe0, 0x10, 0x1c, 0x0d, 0xd0, 0x01, 
    0x38, 0x09, 0xd0, 0x01, 0x38, 0x05, 0xd0, 0x01, 0x38, 0x01, 0xd0, 0x10, 0x20, 0x06, 0xe0, 
    0x0e, 0x20, 0x04, 0xe0, 0x0c, 0x20, 0x02, 0xe0, 0x0a, 0x20, 0x00, 0xe0, 0x08, 0x20, 0xc0, 
    0x19, 0xc1, 0x7b, 0x40, 0x4b, 0x19, 0x70, 0x03, 0x7c, 0x3f, 0x48, 0x03, 0x70, 0x03, 0x20, 
    0x3f, 0x49, 0x01, 0x24, 0xa6, 0x46, 0x3e, 0x4c, 0xfe, 0x44, 0x20, 0x47, 0xf8, 0xbd, 0x30, 
    0xb5, 0x00, 0x20, 0x4c, 0x49, 0x08, 0x70, 0x4c, 0x48, 0xf7, 0x21, 0x01, 0x70, 0xff, 0x21, 
    0x41, 0x70, 0x81, 0x70, 0x7f, 0x21, 0xc1, 0x70, 0x20, 0x4a, 0x10, 0x1f, 0x38, 0x49, 0x08, 
    0x60, 0x1d, 0x4b, 0x01, 0x21, 0x19, 0x70, 0x37, 0x48, 0x10, 0x60, 0x02, 0x25, 0x38, 0x48, 
    0x04, 0x1c, 0x33, 0x34, 

    0x01, 0x05, 0xff, 0xff, 0xbe, 0x0a, 0x18, 0x00, 0xfa, 0x25, 0x70, 0x34, 0x4c, 0x54, 0x60, 
    0x03, 0x24, 0x1c, 0x71, 0x33, 0x4c, 0x94, 0x60, 0x04, 0x24, 0x04, 0x70, 0x33, 0x4c, 0xd4, 
    0x60, 0x05, 0x24, 0xc4, 0x73, 0x32, 0x4c, 0x14, 0x61, 0x06, 0x24, 0x9c, 0x71, 0x31, 0x4c, 
    0x54, 0x61, 0x07, 0x24, 0xdc, 0x71, 0xdc, 0x1d, 0x30, 0x4d, 0x95, 0x61, 0x08, 0x25, 0x15, 
    0x38, 0x05, 0x70, 0x2e, 0x48, 0xd0, 0x61, 0x09, 0x20, 0x60, 0x77, 0x2d, 0x48, 0x10, 0x62, 
    0x0a, 0x20, 0xc3, 0x18, 0x18, 0x70, 0x2c, 0x48, 0x50, 0x62, 0x0b, 0x20, 0xd8, 0x75, 0x2b, 
    0x4b, 0x93, 0x62, 0x03, 0x4a, 0x10, 0x70, 0x8e, 0x46, 0x29, 0x48, 0xfe, 0x44, 0x00, 0x47, 
    0x30, 0xbd, 0xb4, 0x63, 0x08, 0x00, 0x8c, 0x53, 0x08, 0x00, 0xb8, 0x63, 0x08, 0x00, 0x4d, 
    0x76, 0x08, 0x00, 0x57, 0x76, 0x08, 0x00, 0x39, 0x76, 0x08, 0x00, 0x01, 0x64, 0x08, 0x00, 
    0xf6, 0x63, 0x08, 0x00, 0xf9, 0x63, 0x08, 0x00, 0xf8, 0x63, 0x08, 0x00, 0xfa, 0x63, 0x08, 
    0x00, 0x07, 0xff, 0x03, 0x00, 0xd7, 0xd3, 0x04, 0x00, 0x16, 0xf6, 0x1a, 0x00, 0xd3, 0x48, 
    0x05, 0x00, 0x8c, 0x7c, 0x1a, 0x00, 0xa7, 0x48, 0x05, 0x00, 0x21, 0x99, 0x05, 0x00, 0xbb, 
    0x16, 0x04, 0x00, 0xf7, 0x63, 0x08, 0x00, 0x67, 0x99, 0x05, 0x00, 0xf4, 0x63, 0x08, 0x00, 
    0xf5, 0x63, 0x08, 0x00, 0xae, 0x05, 0x00, 0x00, 0x0b, 0xd4, 0x04, 0x00, 0xff, 0xff, 0xff, 
    0x1f, 0x91, 0x48, 0x05, 0x00, 0x88, 0x53, 0x08, 0x00, 0x1b, 0x76, 0x08, 0x00, 0x43, 0x76, 
    0x08, 0x00, 0x75, 0x76, 0x08, 0x00, 0xca, 0x53, 0x08, 0x00, 0x7f, 0x76, 0x08, 0x00, 0x61, 
    0x76, 0x08, 0x00, 0x6b, 0x76, 0x08, 0x00, 0x11, 0x76, 0x08, 0x00, 0x07, 0x76, 0x08, 0x00, 
    0xfd, 0x75, 0x08, 0x00, 

    0x01, 0x05, 0xff, 0x19, 0xb8, 0x0b, 0x18, 0x00, 0x14, 0x2f, 0x76, 0x08, 0x00, 0x25, 0x76, 
    0x08, 0x00, 0x11, 0x08, 0x18, 0x00, 0xfb, 0x63, 0x08, 0x00, 0xf0, 0x63, 0x08, 0x00, 

    0x01, 0x83, 0xff, 0x14, 0x79, 0x7b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

    // 
    // 
    0x01, 0xdc, 0xfd, 0x05, 0x00, 0x00, 0x00, 0x00, 0x12, 

    0x01, 0x0f, 0xfd, 0x01, 0x01, 

    // 
    // 
    // ##--------------------------------------------------------------------------------
    // ## Description:   QRCA_L_TRIOL PHY FW Initialization Script
    // ## Version:       3.17_3 (based on ROM version)
    // ##--------------------------------------------------------------------------------
    0x01, 0x01, 0xff, 0x06, 0xc6, 0x32, 0x19, 0x00, 0x10, 0x10, 

    0x01, 0x01, 0xff, 0x06, 0x60, 0x32, 0x19, 0x00, 0x32, 0x10, 

    0x01, 0x82, 0xfd, 0x14, 0x00, 0x9c, 0x18, 0xd2, 0xd2, 0xd2, 0xd2, 0xd2, 0xd2, 0xd2, 0xdc, 
    0xe6, 0xf0, 0xfa, 0x04, 0x0e, 0x18, 0xff, 0x00, 0x00, 

    0x01, 0x82, 0xfd, 0x14, 0x01, 0x9c, 0xce, 0xce, 0xce, 0xce, 0xce, 0xce, 0xce, 0xce, 0xd8, 
    0xe2, 0xec, 0xf6, 0x00, 0x0a, 0x14, 0xff, 0x00, 0x00, 

    0x01, 0x82, 0xfd, 0x14, 0x02, 0x9c, 0xce, 0xce, 0xce, 0xce, 0xce, 0xce, 0xce, 0xce, 0xd8, 
    0xe2, 0xec, 0xf6, 0x00, 0x0a, 0x14, 0xff, 0x00, 0x00, 

    0x01, 0x87, 0xfd, 0x03, 0x0d, 0x0d, 0x0d, 

    0x01, 0x76, 0xfd, 0x31, 0x01, 0x21, 0x54, 0x00, 0x00, 0x61, 0x57, 0x00, 0x00, 0x14, 0x05, 
    0x0a, 0x05, 0x00, 0x07, 0x06, 0x0a, 0x04, 0x05, 0x08, 0x09, 0x0b, 0x0c, 0x0d, 0x0e, 0x10, 
    0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 
    0x10, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00, 

    0x01, 0x80, 0xfd, 0x06, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 

    0x01, 0x80, 0xfd, 0x06, 0x3c, 0xf0, 0x5f, 0x00, 0x00, 0x00, 

    // 
    // 
    // 
    0x01, 0x38, 0xfe, 0x00, 

    // 
    // # BLE
    // #--------------------------------------------------------------------------------
    // # Description:   BRF6450 WB FW Initialization Script
    // #
    // # Compatibility: BRF6450 PG1 ROM
    // #
    // # Last Updated:  07-Oct-2010  15:19:44.57
    // #
    // # Version:       1.0
    // #
    // #--------------------------------------------------------------------------------
    // 
    // 
    // #BLE Enable
    0x01, 0x5b, 0xfd, 0x02, 0x01, 0x01, 

    // 
    // # Disable Cortex Sleep
    0x01, 0xa8, 0xfd, 0x01, 0x01, 

    // 
    // 
    // # Cortex Reset (hold in reset while loading IMEM)
    0x01, 0x09, 0xfd, 0x08, 0x00, 0xc0, 0x1b, 0x00, 0x01, 0x00, 0x01, 0x00, 

    // ########################
    // # Patch Start
    // ########################
    // 
    0x01, 0x05, 0xff, 0x41, 0x60, 0x5c, 0x1b, 0x00, 0x3c, 0x01, 0x68, 0xb1, 0xf1, 0xff, 0x3f, 
    0x1c, 0xbf, 0x49, 0x1c, 0x01, 0x60, 0x13, 0xd1, 0x41, 0x68, 0x00, 0x23, 0x03, 0x60, 0x01, 
    0xf0, 0x7f, 0x02, 0x7f, 0x2a, 0x04, 0xbf, 0x21, 0xf0, 0x7f, 0x01, 0x41, 0x60, 0x4f, 0xea, 
    0x41, 0x62, 0x06, 0xd0, 0x02, 0xf1, 0x00, 0x72, 0x21, 0xf0, 0x7f, 0x01, 0x41, 0xea, 0x52, 
    0x61, 0x41, 0x60, 0x70, 0x47, 0x00, 0x00, 0xf0, 0xb5, 

    0x01, 0x05, 0xff, 0xcd, 0x8c, 0x6e, 0x1b, 0x00, 0xc8, 0x40, 0xf2, 0x00, 0x04, 0xc2, 0xf2, 
    0x00, 0x04, 0xd4, 0xf8, 0x8c, 0x25, 0x40, 0xf2, 0x00, 0x05, 0x01, 0x78, 0x6f, 0xf3, 0x1f, 
    0x42, 0xc2, 0xf2, 0x30, 0x05, 0x15, 0x43, 0x42, 0xf2, 0x6c, 0x4b, 0x29, 0x80, 0x43, 0xf2, 
    0x00, 0x02, 0xc4, 0xf2, 0x00, 0x0b, 0x00, 0x23, 0xab, 0xf8, 0x00, 0x30, 0x4f, 0xf4, 0x20, 
    0x63, 0xc2, 0xf2, 0x31, 0x02, 0x01, 0x21, 0x41, 0xf2, 0x08, 0x46, 0x40, 0x27, 0x4f, 0xf0, 
    0x78, 0x0c, 0x53, 0x80, 0x16, 0x80, 0xd7, 0x83, 0xa2, 0xf8, 0x1c, 0xc0, 0x91, 0x80, 0x11, 
    0x84, 0x02, 0x78, 0x10, 0x2a, 0x80, 0xf2, 0xbf, 0x80, 0x13, 0x46, 0x00, 0x2b, 0x05, 0xf1, 
    0x02, 0x05, 0x2b, 0xd0, 0x5b, 0x1e, 0x1d, 0xd0, 0x5b, 0x1e, 0x0e, 0xd0, 0x5b, 0x1e, 0x30, 
    0xd1, 0x42, 0xf2, 0x46, 0x42, 0xc2, 0xf2, 0x31, 0x02, 0x00, 0x23, 0x93, 0x80, 0x11, 0x80, 
    0x02, 0x78, 0x4f, 0xf4, 0x80, 0x7a, 0x41, 0xf2, 0x11, 0x08, 0x23, 0xe0, 0x42, 0xf2, 0x46, 
    0x42, 0xc2, 0xf2, 0x31, 0x02, 0x02, 0x23, 0x93, 0x80, 0x11, 0x80, 0x02, 0x78, 0x4f, 0xf4, 
    0x80, 0x7a, 0x41, 0xf2, 0x11, 0x08, 0x16, 0xe0, 0x42, 0xf2, 0x46, 0x42, 0xc2, 0xf2, 0x31, 
    0x02, 0x02, 0x23, 0x93, 0x80, 0x11, 0x80, 0x02, 0x78, 0x8a, 0x46, 0x41, 0xf2, 0x01, 0x18, 
    0x0a, 0xe0, 0x42, 0xf2, 0x46, 0x42, 0xc2, 0xf2, 0x31, 0x02, 0x00, 0x23, 0x93, 0x80, 

    0x01, 0x05, 0xff, 0xcd, 0x54, 0x6f, 0x1b, 0x00, 0xc8, 0x11, 0x80, 0x41, 0xf2, 0x10, 0x18, 
    0x8a, 0x46, 0x02, 0x78, 0x42, 0xf2, 0x48, 0x49, 0x4f, 0xf2, 0x04, 0x07, 0x10, 0x2a, 0x7c, 
    0xda, 0xc2, 0xf2, 0x31, 0x09, 0xc2, 0xf2, 0x32, 0x07, 0x00, 0x20, 0x00, 0x26, 0xab, 0xf8, 
    0x00, 0x00, 0x25, 0xf8, 0x02, 0x6b, 0x4f, 0xf0, 0x15, 0x0e, 0xa9, 0xf8, 0x00, 0xe0, 0x94, 
    0xf8, 0x05, 0x26, 0x10, 0x2a, 0x04, 0xda, 0x39, 0x88, 0x01, 0x20, 0x90, 0x40, 0x08, 0x43, 
    0x38, 0x80, 0xc6, 0xf1, 0xfa, 0x00, 0x80, 0xb2, 0xfe, 0xf7, 0xb7, 0xfb, 0x11, 0x20, 0xa9, 
    0xf8, 0x00, 0x00, 0x94, 0xf8, 0x10, 0x26, 0x10, 0x2a, 0x04, 0xda, 0x39, 0x88, 0x01, 0x20, 
    0x90, 0x40, 0x08, 0x43, 0x38, 0x80, 0xfa, 0x20, 0xfe, 0xf7, 0xa8, 0xfb, 0xbb, 0xf8, 0x00, 
    0x00, 0x1a, 0xea, 0x00, 0x0f, 0x25, 0xf8, 0x02, 0x0b, 0x02, 0xd0, 0x18, 0xea, 0x00, 0x0f, 
    0x09, 0xd0, 0x94, 0xf8, 0x49, 0x06, 0x40, 0xf0, 0x04, 0x00, 0x84, 0xf8, 0x49, 0x06, 0x4f, 
    0xf4, 0xfa, 0x70, 0xfe, 0xf7, 0x94, 0xfb, 0x10, 0x20, 0xa9, 0xf8, 0x00, 0x00, 0x94, 0xf8, 
    0x10, 0x26, 0x38, 0x46, 0x10, 0x2a, 0x08, 0xda, 0x01, 0x88, 0x4f, 0xf0, 0x01, 0x0e, 0x0e, 
    0xfa, 0x02, 0xf0, 0x81, 0x43, 0xbc, 0x46, 0xac, 0xf8, 0x00, 0x10, 0x32, 0x20, 0xfe, 0xf7, 
    0x80, 0xfb, 0x14, 0x20, 0xa9, 0xf8, 0x00, 0x00, 0x94, 0xf8, 0x05, 0x26, 0x38, 0x46, 

    0x01, 0x05, 0xff, 0xcd, 0x1c, 0x70, 0x1b, 0x00, 0xc8, 0x10, 0x2a, 0x08, 0xda, 0x01, 0x88, 
    0x4f, 0xf0, 0x01, 0x0e, 0x0e, 0xfa, 0x02, 0xf0, 0x81, 0x43, 0xbc, 0x46, 0xac, 0xf8, 0x00, 
    0x10, 0x32, 0x20, 0xfe, 0xf7, 0x6c, 0xfb, 0xbb, 0xf8, 0x00, 0x00, 0x41, 0xf2, 0x11, 0x11, 
    0x25, 0xf8, 0x02, 0x0b, 0x01, 0x42, 0x1e, 0xbf, 0x94, 0xf8, 0x49, 0x06, 0x40, 0xf0, 0x08, 
    0x00, 0x84, 0xf8, 0x49, 0x06, 0xc8, 0x20, 0xfe, 0xf7, 0x5b, 0xfb, 0x76, 0x1c, 0xfa, 0x2e, 
    0x4f, 0xf0, 0x00, 0x00, 0x88, 0xd3, 0x94, 0xf8, 0x49, 0x06, 0x00, 0xf0, 0x7f, 0x00, 0x84, 
    0xf8, 0x49, 0x06, 0xbd, 0xe8, 0xf0, 0x8f, 0x30, 0xb5, 0x41, 0xf6, 0x48, 0x44, 0x41, 0xf6, 
    0x30, 0x45, 0x00, 0x21, 0x03, 0x20, 0xc2, 0xf2, 0x00, 0x04, 0xc2, 0xf2, 0x00, 0x05, 0x0a, 
    0x46, 0x63, 0x7a, 0xe8, 0x75, 0xf9, 0xf7, 0x57, 0xfb, 0x63, 0x7a, 0xe8, 0x7d, 0x00, 0x22, 
    0x01, 0x21, 0xf9, 0xf7, 0x51, 0xfb, 0x40, 0xf6, 0x6a, 0x20, 0x07, 0x21, 0xc2, 0xf2, 0x32, 
    0x00, 0xff, 0xf7, 0xbc, 0xfa, 0x00, 0x21, 0x22, 0x7a, 0x31, 0x20, 0xff, 0xf7, 0x0d, 0xfa, 
    0x43, 0xf2, 0x5c, 0x10, 0x00, 0x21, 0xc2, 0xf2, 0x31, 0x00, 0xff, 0xf7, 0xb0, 0xfa, 0x20, 
    0x7a, 0x10, 0xb9, 0x00, 0xf0, 0x79, 0xff, 0x30, 0xbd, 0x00, 0xf0, 0xdf, 0xfe, 0x30, 0xbd, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

    0x01, 0x05, 0xff, 0xcd, 0xe4, 0x70, 0x1b, 0x00, 0xc8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

    0x01, 0x05, 0xff, 0x11, 0xac, 0x71, 0x1b, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

    0x01, 0x05, 0xff, 0x15, 0x0c, 0x7f, 0x1b, 0x00, 0x10, 0x10, 0xbd, 0x00, 0xb5, 0x41, 0xf6, 
    0x50, 0x40, 0xc2, 0xf2, 0x00, 0x00, 0x00, 0x21, 0x02, 0x78, 

    0x01, 0x05, 0xff, 0x15, 0x30, 0x7f, 0x1b, 0x00, 0x10, 0xff, 0xf7, 0xa0, 0xf8, 0x00, 0xbd, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

    // 
    // ########################
    // # Patch End
    // ########################
    // 
    // #release Cortex Reset
    0x01, 0x09, 0xfd, 0x08, 0x00, 0xc0, 0x1b, 0x00, 0x00, 0x00, 0x01, 0x00, 

    // 
    // # Enable Cortex Sleep
    0x01, 0xa8, 0xfd, 0x01, 0x00, 

    // 
    // #RESET BLE
    0x01, 0x5b, 0xfd, 0x02, 0x01, 0x00, 

    // 
    0x01, 0xdd, 0xfd, 0x01, 0x01, 

    // 
    // #################################################################
    // ## START of Panasonic Adds-On
    // #################################################################
    // 
    // ## Enable fast clock XTAL support
    0x01, 0x1c, 0xfd, 0x14, 0x01, 0x88, 0x13, 0x00, 0x00, 0xd0, 0x07, 0x00, 0x00, 0xff, 0xff, 
    0x04, 0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x00, 0x00, 

    // 
    // ## Enable LPS
    0x01, 0x2e, 0xfd, 0x0d, 0x01, 0x58, 0x02, 0x06, 0x00, 0x1e, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 

    // 
    // ## Enable eHCILL
//    0x01, 0x2b, 0xfd, 0x05, 0x10, 0x00, 0x50, 0x00, 0x96, 

//DGV: disable eHCILL
    0x01, 0x0c, 0xfd, 0x09 , 0x01, 0, 0,  0xff, 0xff, 0xff, 0xff, 100, 0,

    // 
 //   0x01, 0x0c, 0xfd, 0x09, 0x01, 0x01, 0x00, 0xff, 0xff, 0xff, 0xff, 0x64, 0x00, 

    // 
    // #################################################################
    // ## END of Panasonic Adds-On
    // #################################################################


    //terminate
    0x00
};
#endif   // #if  defined(BT_MODULE_CC256X)
